      subroutine base

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  base:    Updated     2004 October 5 16:40.
c               base:    Originated  2004 October 5 16:40.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To display the digits of decimal numbers in a
c               specified number base.
c
c     Logic:    Entry points:  base
c base          Called by:  helpall, main.
c
c base          Calls:  aptbase, varfind.
c
c     Biblio:   ?
c
c     Glossary:
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

      integer il(60)                  ! Digits to the left of point.
      integer ir(60)                  ! Digits to the right of point.

      character*1 ahex(16)            ! Hexadecimal digits.

      data ahex / '0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
     &            'A', 'B', 'C', 'D', 'E', 'F' /

c=======================================================================********

c.... Input line:  base [help]

 8110 format ('  Command "base":  acceptable input lines',
     &  ' include:' //
     &  '  "base [help]"  Display this message.' //
     &  '  "base NBASE VALUE1 VALUE2 VALUE3 ..."' /
     &  '     Display the values in base NBASE of the decimal' /
     &  '     values VALUE1, VALUE2, VALUE3, ...' //
     &  '  Synonyms:  [help, h].' )

      if ((nword .eq. 1) .or.
     &   ((nword .eq. 2) .and.
     &   ((aword(2) .eq. 'help') .or.
     &    (aword(2) .eq. 'h')))) then
        write (   6, 8110)
        write (iout, 8110)
        go to 999
      endif

c=======================================================================********

c.... Check for error.

 8120 format ('  base ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Not 3 or more  words on "base" line:  ', i3)

      if (nword .le. 2) then
        write (   6, 8120) ainput, ninput, nword
        write (iout, 8120) ainput, ninput, nword
        go to 999
      endif

c=======================================================================********

c.... Input line:  base NBASE VALUE1 VALUE2 VALUE3 ...

c.... Find the number base.

      call varfind (2, 2)

 8130 format ('  base ERROR.  Reading ',a40,' line ',i5,'.' /
     &        '  Number base is not an integer:',a)

      if (mtype(2) .ne. 2) then
        write (   6, 8130) ainput, ninput, aword(2)
        write (iout, 8130) ainput, ninput, aword(2)
        go to 999
      endif

      nbase = iword(2)

 8140 format ('  base ERROR.  Reading ',a40,' line ',i5,'.' /
     &        '  Number base is not 2 or more:',i20)

      if (nbase .lt. 2) then
        write (   6, 8140) ainput, ninput, iword(2)
        write (iout, 8140) ainput, ninput, iword(2)
        go to 999
      endif

 8150 format ('  base ERROR.  Reading ',a40,' line ',i5,'.' /
     &        '  Value is not integer or floating point:',a)
 8152 format ('  base WARNING.  Reading ',a40,' line ',i5,'.' /
     &        '  Value is negative, will use positive:  ',1pe25.17)

      tolx = tol
      if (tol .le. 1.e-18) tolx = 1.e-18

      do 210 nw = 3, nword

        call varfind (nw, nw)

        if ((mtype(nw) .ne. 2) .and. (mtype(nw) .ne. 3)) then
          write (   6, 8150) ainput, ninput, aword(nw)
          write (iout, 8150) ainput, ninput, aword(nw)
          go to 210
        endif

        if (fword(nw) .lt. 0.0) then
          write (   6, 8152) ainput, ninput, fword(nw)
          write (iout, 8152) ainput, ninput, fword(nw)
        endif

        value = abs (fword(nw))

 8156   format (/ '  Decimal value =  ',1pe25.17)

        write (   6, 8156) value
        write (iout, 8156) value

        call aptbase (value, idmax, nbase, 60, tolx,
     &                nl, il, nr, ir, nerra)

 8160   format (/ '    Base',i5,':  digits to the left  of point =',i3,
     &            '.' /)
 8165   format ('    set il(',i1,')   =',i5)
 8166   format ('    set il(',i2,')  =',i5)
 8168   format (/'    set il      =    ',60i1)
 8169   format (/'        ilhex   =    ',60a1)

        vcheck = 0.0
        fmult  = nbase

        if (nl .ge. 1) then
          write (   6, 8160) nbase, nl
          write (iout, 8160) nbase, nl
          do n = nl, 1, -1
            vcheck = vcheck * fmult + il(n)
            if (n .lt. 10) then
              write (   6, 8165) n, il(n)
              write (iout, 8165) n, il(n)
            else
              write (   6, 8166) n, il(n)
              write (iout, 8166) n, il(n)
            endif
          enddo
          if (nbase .lt. 10) then
            write (   6, 8168) (il(n), n = nl, 1, -1)
            write (iout, 8168) (il(n), n = nl, 1, -1)
          elseif (nbase .eq. 16) then
            write (   6, 8169) (ahex(il(n)+1), n = nl, 1, -1)
            write (iout, 8169) (ahex(il(n)+1), n = nl, 1, -1)
          endif
        endif

 8170   format (/ '    Base',i5,':  digits to the right of point =',i3,
     &            '.' /)
 8175   format ('    set ir(',i1,')   =',i5)
 8176   format ('    set ir(',i2,')  =',i5)
 8178   format (/'    set ir      =  0.',60i1)
 8179   format (/'        irhex   =    0.',60a1)

        finv  = 1.0 / fmult
        fmult = 1.0

        if (nr .ge. 1) then
          write (   6, 8170) nbase, nr
          write (iout, 8170) nbase, nr
          do n = 1, nr
            fmult = fmult * finv
            vcheck = vcheck + fmult * ir(n)
            if (n .lt. 10) then
              write (   6, 8175) n, ir(n)
              write (iout, 8175) n, ir(n)
            else
              write (   6, 8176) n, ir(n)
              write (iout, 8176) n, ir(n)
            endif
          enddo
          if (nbase .lt. 10) then
            write (   6, 8178) (ir(n), n = 1, nr)
          elseif (nbase .eq. 16) then
            write (   6, 8179) (ahex(ir(n)+1), n = 1, nr)
            write (iout, 8179) (ahex(ir(n)+1), n = 1, nr)
          endif
        endif

 8180   format ('  Decimal check =  ',1pe25.17)
 8185   format ('  Decimal error =  ',1pe25.17 //
     &    80('-'))

        verror = vcheck - value

        write (   6, 8156) value
        write (iout, 8156) value
        write (   6, 8180) vcheck
        write (iout, 8180) vcheck
        write (   6, 8185) verror
        write (iout, 8185) verror

  210 continue

c=======================================================================********

  999 return

c.... End of subroutine base.         (+1 line)
      end
