      subroutine bigfind (nw, nbig)

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  bigfind  Updated     2005 September 20 17:50.
c               bigfind  Originated  2005 August 4 14:00.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To find a big integer with the same name as an ASCII argument,
c               or display an error message.
c
c     Logic:    Entry points:  bigfind.
c bigfind       Called by:  bigint, variable.
c
c               Calls:  (none).
c
c     Biblio:   ?
c
c     Glossary:
c
c     aword(nw) Input    Name of big integer to find.
c
c     nbig      Output   Index of big integer.
c
c     nw        Input    Index of input line argument to test.     
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

 8110 format ('  bigind ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Argument number is bad:  ',i5)

      if ((nw .lt. 1)      .or.
     &    (nw .gt. nword)) then
        write (   6, 8110) ainput, ninput, nw
        write (iout, 8110) ainput, ninput, nw
        go to 999
      endif

      nbig = 0

      do 120 n = 1, nbigm            ! Loop over big integers.
cbugc***DEBUG begins.
cbug 9701 format ('bigfind DEBUG.  aword = "',a,'"' /
cbug     &  'n =',i5,'  abig = "',a,'"' )
cbug      write (   6, 9701) aword(nw), n, abig(n)
cbug      write (iout, 9701) aword(nw), n, abig(n)
cbugc***DEBUG ends.
ctemp        if ((ndig(n) .eq. 1) .and. (idig(1,n) .eq. 0)) go to 120
        if (aword(nw) .eq. abig(n)) then
          nbig = n
          go to 999
        endif
  120 continue                        ! End of loop over big integers.

cbug 8120 format ('  bigfind WARNING.  Reading ',a40,' line ',i5,'.' /
cbug     &  '  Named big integer does not exist:  ',a)
cbug
cbug      write (   6, 8120) ainput, ninput, aword(nw)
cbug      write (iout, 8120) ainput, ninput, aword(nw)

  999 continue
cbugc***DEBUG begins.
cbug 9901 format ('bigfind DEBUG.  nw=',i3,'  aword= ',a24,'  nbig=',i3)
cbug      write (   6, 9901) nw, aword(nw), nbig
cbug      write (iout, 9901) nw, aword(nw), nbig
cbugc***DEBUG ends.

      return

c.... End of subroutine bigfind.      (+1 line)
      end
