      subroutine bigzero (nb, nerrzero)

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  bigzero  Updated     2006 April 11 17:00.
c               bigzero  Originated  2005 August 9 15:00.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To zero out big integer abig(nb), stored as an array of base
c               10 single decimal digits.  The result is an integer with one
c               digit, a zero.
c
c     Logic:    Entry points:  bigzero.
c bigzero       Called by:  bigint, bigtran.
c
c     Biblio:   ?
c
c     Glossary:
c
c     nb        Input    Index of big integer to be zeroed out.
c
c     nerrzero  Output   Error indicator:
c                          0 if no error.
c                          1 if nb < 1.
c                          2 if nb > nbigm.
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

c.... Test for errors.
cbugc***DEBUG begins.
cbug 9010 format ('bigzero DEBUG.  nb =',i5,'  abig(nb) = "',a,'"')
cbug      write (   6, 9010) nb, abig(nb)
cbug      write (iout, 9010) nb, abig(nb)
cbugc***DEBUG ends.

      nerrzero = 0

      if (nb .lt. 1) then
        nerrzero = 1
        go to 999
      endif

      if (nb .gt. nbigm) then
        nerrzero = 2
        go to 999
      endif

c.... Zero out big integer nb.

      abigtag(nb) = ' '
      asign(nb)   = ' '
      ndig(nb)    = 1
      do nd = 1, ndigm
        idig(nd,nb) = 0
      enddo

  999 return

c.... End of subroutine bigzero.      (+1 line)
      end
