      subroutine binfind (nw, nb)

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  binfind  Updated     1995 July 7 14:30.
c               binfind  Originated  1995 July 7 14:30.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To find a bin with the same name as an ASCII argument,
c               or the value of an ASCII variable argument,
c               display the bin, or display an error message.
c
c     Logic:    Entry points:  binfind.
c binfind       Called by:  pdf.
c
c binfind       Calls:  binout.
c
c     Biblio:   ?
c
c     Glossary:
c
c     aword(nw) Input    Name of bin to find.
c
c     nb        Output   Index of bin.
c
c     nw        Input    Index of argument to test.     
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

 8110 format ('  binfind ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Argument number is bad:  ',i5)

      if ((nw .lt. 1)      .or.
     &    (nw .gt. nword)) then
        write (   6, 8110) ainput, ninput, nw
        write (iout, 8110) ainput, ninput, nw
        go to 999
      endif

      nb = 0

      do 120 n = 1, nbins           ! Loop over bins.
        if (aword(nw) .eq. abin(n)) then
          nb = n
          call binout (nb, nb, 'min')
          go to 999
        endif
  120 continue                        ! End of loop over bins.

      if ((aword(1) .eq. 'pdf')     .and.
     &    (aword(nw) .eq. 'thru'))  then
        go to 999
      endif

 8120 format ('  binfind ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Named bin does not exist:  ',a)

      write (   6, 8120) ainput, ninput, aword(nw)
      write (iout, 8120) ainput, ninput, aword(nw)

  999 return

c.... End of subroutine binfind.      (+1 line)
      end
