      subroutine binstore (nrep, n)

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  binstore Updated     1994 June 30 10:30.
c               binstore Originated  1994 June 21 12:20.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To find the index in the bin array in which to store the bin
c               being created.
c
c     Logic:    Entry point:  binstore.f.
c binstore      Called by:  bin.
c
c binstore      Calls:  binout.
c               Calls:  (none).
c
c     Biblio:   ?
c
c     Glossary:
c
c     n         Output   0 if bin array is full.  No room for a new bin.
c                          Positive if the index where the new bin is to
c                          be stored.
c
c     nrep      Output   0 if bin name is new, 1 if an old bin with the
c                          same name is being replaced.
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

c.... Local variables.

      character*8 amount              ! Amount of output data.

      n = 0

c.... See if the bin name already exists.

 8110 format ('  WARNING:  replacing existing bin:  ',a)

      nrep = 0

      do 110 np = 1, nbins
        if (aword(2) .eq. abin(np)) then
          nrep = 1
          n = np
          write (   6, 8110) abin(np)
          write (iout, 8110) abin(np)
          amount = 'minimum'
          call binout (np, np, amount)
          go to 999
        endif
  110 continue

c.... See if a null bin can be replaced.

      do 120 np = 1, nbins
        if (abin(np) .eq. ' ') then
          n = np
          go to 999
        endif
  120 continue

c.... See if the maximum number of bins has been exceeded.

 8130 format ('  binstore ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Number of bins exceeds limit ',i5)

      if ((nbins + 1) .gt. nbinm) then
        write (   6, 8130) ainput, ninput, nbinm
        write (iout, 8130) ainput, ninput, nbinm
        n = 0
        go to 999
      endif

c.... Add a new bin at the end of the list.

      nbins = nbins + 1

      n = nbins

c=======================================================================********

  999 return

c.... End of subroutine binstore.     (+1 line)
      end
