      subroutine getio

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  getio    Updated     2004 November 23 13:30.
c               getio    Originated  1993 November 3 13:30.
c
c     Purpose:  To get execution line message, if any, and assign output file,
c               if necessary.
c     Logic:
c getio         Called by:  main.
c
c getio         Calls:  geomend, getarg, openx.
c               System calls:  getarg, iargc, openx.
c
c     History:  1993 October 27 14:00.  Replaced stop with call geomend, with
c                 a termination message.
c               1993 November 1 10:00.  Moved initialization of version name,
c                 date and time to main from getio.
c               2004 March 9 15:00.  Added names of input file and output file
c                 to the GEOM execution line.
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

c.... Local variables.  See geom.base.

      common /agetio/ isize           ! File size.
      common /agetio/ iopt            ! File open option.

c.... Type character variables.

      common /agetio/ atype           ! File type.
      character*8     atype           ! File type.
      common /agetio/ atermess        ! Termination message.
      character*80    atermess        ! Termination message.

c.... Get execution line symbols.

      nword = iargc ()                         

      if (nword .le. 0) go to 110

      if ((nword .gt. 0) .and. (nword .le. 40)) then
        do 100 n = 1, nword
          call getarg (n, aword(n))   ! Input file name.
  100   continue
      endif

 9110 format ('getio DEBUG.  nword =',i5)
      write (   *, 9110) nword

      if (nword .eq. 1) then
        if (aword(1) .eq. 'geom.cmd') go to 105
        if (aword(1) .eq. 'geom.hsp') go to 105
        ainputex  = aword(1)
        go to 110
      endif

      if (nword .eq. 2) then
        if (aword(1) .eq. 'geom.cmd') go to 105
        if (aword(1) .eq. 'geom.hsp') go to 105
        if (aword(2) .eq. 'tty'     ) go to 105
        if (aword(2) .eq. 'geom.cmd') go to 105
        ainputex  = aword(1)
        aoutputex = aword(2)
        go to 110
      endif

 8110 format ('  getio ERROR.  Usage is:  geom [IN_FILE] [[OUT_FILE]]' /
     &  '  IN_FILE  may not be "geom.cmd" or "geom.hsp". ' /
     &  '  OUT_FILE may not be "geom.cmd" or "tty". ' )

  105 write (   *, 8110)
      atermess = 'GEOM getio ERROR.  Try again.'
      call geomend (atermess)

c=======================================================================********

c.... Set name of output file.

  110 if (aoutputex .eq. ' ') then
        afilout = 'geom.hsp'
      else
        afilout = aoutputex
      endif

c.... Find output unit.

      iout = 3

c.... Open or create output file.

      iopt = 0                        ! Open or create output file.
      isize = 100000

      atype = 'hardcopy'
      call openx (iout, afilout, atype, iopt, isize)

c=======================================================================********

c.... Set name of command file.

      afilcmd = 'geom.cmd'

c.... Find output unit.

      icmd = 24

c.... Open or create command file.

      iopt = 0                        ! Open or create output file.
      isize = 100000

      atype = 'hardcopy'
      call openx (icmd, afilcmd, atype, iopt, isize)

c=======================================================================********

c.... Display the version date, time and machine.

 8270 format ('  Version ',a,' Loaded on ',a,' at ',a,' on ',a)

      write (iout, 8270) aversion, aloddate, alodtime, alodmach

c=======================================================================********

      return                          ! To main.

c.... End of subroutine getio.        (+1 line)
      end
