      subroutine helpobj

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  helpobj  Updated     2006 January 6 14:40.
c               helpobj  Originated  1994 September 23 10:00.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To display a help message for commands that create and
c               display objects.
c
c     Logic:    Entry points:  helpobj.
c helpobj       Called by:  helpall, main.
c               Calls:  (none).
c
c     Biblio:   ?
c
c     Glossary:
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

c.... Help message.

c.... Input line:  help object
c.... Input line:  object [help]

 8110 format (/ '  Commands to create and display objects include:' //
     &  '  alias, al, a              Create/display aliases.' //
     &  '  big                       Create/display big integers,   ',
     &  ' do math.' /
     &  '  variable, var, set, s     Create/display named variables,',
     &  ' do math.' /
     &  '  vector, vect, v           Create/display vectors.' /
     &  '  operator, oper, op        Create/display operators to',
     &  ' reflect, rotate,' /
     &  '                              invert or scale.' //
     &  '  point, pnt, pt, p         Create/display points.' /
     &  '  cluster, cl               Create/display clusters of',
     &  ' points.' /
     &  '  marker, mark, m           Specify/display markers and their',
     &  ' text.' /
     &  '  line, ln, l               Create/display lines.' /
     &  '  triangle, tri             Create/display triangles.',
     &  '  See trig, cute, cuts.' /
     &  '  polygon, polyg, pg        Create/display regular',
     &  ' polygons.' /
     &  '  disk, dk                  Create/display annular',
     &  ' disks.' )

 8112 format ( 
     &  '  plane, pl                 Create/display planes.' /
     &  '  sphere, sph               Create/display spheres.' /
     &  '  cylinder, cyl             Create/display circular',
     &  ' cylinders.' /
     &  '  cone                      Create/display circular',
     &  ' cones.' /
     &  '  ellipsoid, ell, el        Create/display ellipsoids.' /
     &  '  axisym                    Create/display axisymmetric',
     &  ' quadric surfaces.' /
     &  '  hyperb, saddle            Create/display quadric surface',
     &  ' through quadrangle.' /
     &  '  quadric, quad, q          Create/display general quadric',
     &  ' surfaces.' )

 8114 format (/
     &  '  mesh                      Create/display a logical mesh.' /
     &  '  mesh block                Create/display a logical mesh',
     &  ' block.' /
     &  '  polyhedron, polyh, ph     Create/display regular',
     &  ' polyhedrons.' /
     &  '  tetrahedron, tetra, tet   Create/display tetrahedrons.' /
     &  '  brick, br                 Create/display bricks.' /
     &  '  zone, zn, z               Create/display zones.' //
     &  '  bin                       Create/display probability',
     &  ' bins.' /
     &  '  pdf                       Create/display probability',
     &  ' distribution functions.' //
     &  '  copy, cp, duplicate, dup  Copy an object.' /
     &  '  delete, del, remove, rm   Delete objects.' /
     &  '  switch, sw, rename        Rename objects.' //
     &  '  last                      Create/display base names of',
     &  ' objects.' /
     &  '  list                      Display names of objects.' /
     &  '  repack                    Remove deleted objects.' /
     &  '  sort                      Sort objects by names.' )

        write (   6, 8110)
        write (iout, 8110)
        write (   6, 8112)
        write (iout, 8112)
        write (   6, 8114)
        write (iout, 8114)

      return

c.... End of subroutine helpobj.      (+1 line)
      end
