      subroutine icalc

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  icalc    Updated     2004 November 23 13:30.
c               icalc    Originated  1994 May 3 16:00.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To do arithmetic operations on integers specified in dec, hex
c               or oct mode, and display the results in dec, hex and octal mode,
c               and optionally, binary mode.
c
c     Logic:    Entry points:  icalc.
c icalc         Called by:  helpall, main.
c
c icalc         Calls:  aptbitb, aptbite, aptchai, aptchia, aptchrp, aptcmad,
c               aptcomf, aptmord, aptperf, aptrins.
c
c     Biblio:   ?
c
c     Glossary:
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

cold      integer*4 intm                  ! First input integer.
cold      integer*4 intn                  ! Second input integer.
cold      integer*4 intk                  ! Check integer.
cold      integer*4 intr                  ! Result integer.
c**** Try integer*8 for these local integers.
      integer*8 intm                  ! First input integer.
      integer*8 intn                  ! Second input integer.
      integer*8 intk                  ! Check integer.
      integer*8 intr                  ! Result integer.
      character*80 awordx
      character*80 awordy
      character*32 achold
      character*32 achnew

      dimension intmex (64)           ! Bit array for intm.
      integer*1 intmex                ! Bit array for intm.
      dimension intnex (64)           ! Bit array for intn.
      integer*1 intnex                ! Bit array for intn.
      dimension intrex (64)           ! Bit array for intr.
      integer*1 intrex                ! Bit array for intr.

      integer   intarg(2)             ! Integer args to aptcmad.

c===============================================================================

c.... Initialize at beginning of problem.

      if (nword .eq. 0) then
        amode = 'dec'
        abind = 'nobin'
        go to 999
      endif

c===============================================================================

c.... Input line:  icalc [help]

 8110 format ('  Command "icalc":  acceptable input lines include:' /
     &  '  "icalc [help]"              Display this message.' //
     &  '  "icalc [octal,dec,hex]"  Change the mode of integer',
     &  ' input to icalc' /
     &  '     to [octal, decimal, hexadecimal].' //
     &  '  "icalc binary"              Turn on  the display of the',
     &  ' integer results' /
     &  '     of command "icalc" in binary mode.' /
     &  '  "icalc nobin"               Turn off the display of the',
     &  ' integer results' /
     &  '     of command "icalc" in binary mode (default option).' //
     &  '  "icalc M"                       Interpret integer M in the',
     &  ' current mode.' //
     &  '  "icalc M FUNCTION N"            Interpret integers M and N',
     &  ' in the current' /
     &  '     mode, and do the operation on them specified by',
     &  ' FUNCTION:' //
     &  '     (+,      M + N),           (-,      M - N)' /
     &  '     (*,      M * N),           (/,      M / N)' //
     &  '     (**,     M**N),            (mod,    mod(M, N))' /
     &  '     (max,    max0(M, N)),      (min,    min0(M, N))' /
     &  '     (abs,    M * iabs(N)),     (sign,   isign(M, N))' /
     &  '     (fact,   M * N!),          (ran,    ran(M, N)),' //
     &  '     (comp.,  M * comp. N),     (.not.   M .not.  N),' /
     &  '     (.and.,  M .and.   N),     (.nand.  M .nand. M),' /
     &  '     (.or.,   M .or.    N),     (.nor.   M .nor.  N),' /
     &  '     (.xor.,  M .xor.   N),     (.xnor.  M .xnor. N),' //
     &  '     (gcd,    GCD (M, N),       (lcm,    LCM (M, N).' /
     &  '     (perm,   P(M,N) (permut)   (comb,   C(M,N) (combin)' //
     &  '  Synonyms:  [^, **], [binary, bin], [help, h],',
     &  ' [octal, oct].' //
     &  '  Maximum positive integer values:' /
     &  '  PHYSNET:      2147483647 dec          7fffffff hex',
     &  '             17777777777 oct' /
     &  '  Cray:     70368744177663 dec      3fffffffffff hex',
     &  '        1777777777777777 oct' /
     &  '  DEC: 1152921504606846975 dec   FFFFFFFFFFFFFFF hex',
     &  '    77777777777777777777 oct' )

      if ((nword .eq. 1) .or.
     &   ((nword .eq. 2) .and.
     &   ((aword(2) .eq. 'help') .or.
     &    (aword(2) .eq. 'h')))) then
        write (   6, 8110)
        write (iout, 8110)
        write (   6, 8140) amode
        write (iout, 8140) amode

        if (abind .eq. 'bin') then
          write (   6, 8150)
          write (iout, 8150)
        else
          write (   6, 8160)
          write (iout, 8160)
        endif

        go to 999
      endif

c===============================================================================

c.... Test input for validity.

 8120 format ('  icalc ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Number of words on "icalc" line not 2 or 4:  ',i3)

      if ((nword .ne. 2)  .and.
     &    (nword .ne. 4)) then
        write (   6, 8120) ainput, ninput, nword
        write (iout, 8120) ainput, ninput, nword
        go to 999
      endif

c===============================================================================

c.... Input line:  icalc [dec,hex,oct]

      if (nword .eq. 2) then

c....   Find the new value of amode.

 8140   format (/ '  The integer input mode is ',a3,'.')

        if (aword(2) .eq. 'dec') then
          amode = 'dec'
          write (   6, 8140) amode
          write (iout, 8140) amode
          go to 999
        elseif (aword(2) .eq. 'hex') then
          amode = 'hex'
          write (   6, 8140) amode
          write (iout, 8140) amode
          go to 999
        elseif ((aword(2) .eq. 'octal') .or.
     &          (aword(2) .eq. 'oct'))   then
          amode = 'oct'
          write (   6, 8140) amode
          write (iout, 8140) amode
          go to 999
        endif

      endif                       ! Input line:  icalc [dec,hex,oct]

c===============================================================================
 
c.... Input line:  icalc [binary,nobin]

      if (nword .eq. 2) then

c....   Find the new value of abind.

 8150   format (/ '  The binary display for command "icalc" is on.')
 8160   format (/ '  The binary display for command "icalc" is off.')

        if ((aword(2) .eq. 'binary') .or.
     &      (aword(2) .eq. 'bin'))   then
          abind = 'bin'
          write (   6, 8150)
          write (iout, 8150)
          go to 999
        elseif (aword(2) .eq. 'nobin') then
          abind = 'nobin'
          write (   6, 8160)
          write (iout, 8160)
          go to 999
        endif

      endif

c===============================================================================

c.... Input line:  icalc M
c.... Input line:  icalc M *        N
c.... Input line:  icalc M **       N
c.... Input line:  icalc M +        N
c.... Input line:  icalc M -        N
c.... Input line:  icalc M .eqv.    N
c.... Input line:  icalc M .int.    N
c.... Input line:  icalc M .nor.    N
c.... Input line:  icalc M .not.    N
c.... Input line:  icalc M .un.     N
c.... Input line:  icalc M .xor.    N
c.... Input line:  icalc M /        N
c.... Input line:  icalc M abs      N
c.... Input line:  icalc M comb     N
c.... Input line:  icalc M comp.    N
c.... Input line:  icalc M fact     N
c.... Input line:  icalc M FUNCTION N
c.... Input line:  icalc M gcd      N
c.... Input line:  icalc M lcm      N
c.... Input line:  icalc M max      N
c.... Input line:  icalc M min      N
c.... Input line:  icalc M mod      N
c.... Input line:  icalc M perm     N
c.... Input line:  icalc M ran      N
c.... Input line:  icalc M sign     N

 8135 format ('  icalc ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Word 3 is not a recognized function:  ',a)

      if (nword .eq. 4) then
        if ((aword(3) .ne. '*')      .and.
     &      (aword(3) .ne. '**')     .and.
     &      (aword(3) .ne. '+')      .and.
     &      (aword(3) .ne. '-')      .and.
     &      (aword(3) .ne. '.and.')  .and.
     &      (aword(3) .ne. '.eqv.')  .and.
     &      (aword(3) .ne. '.int.')  .and.
     &      (aword(3) .ne. '.nand.') .and.
     &      (aword(3) .ne. '.nor.')  .and.
     &      (aword(3) .ne. '.not.')  .and.
     &      (aword(3) .ne. '.or.')   .and.
     &      (aword(3) .ne. '.un.')   .and.
     &      (aword(3) .ne. '.xnor.') .and.
     &      (aword(3) .ne. '.xor.')  .and.
     &      (aword(3) .ne. '/')      .and.
     &      (aword(3) .ne. 'abs')    .and.
     &      (aword(3) .ne. 'comb')   .and.
     &      (aword(3) .ne. 'comp.')  .and.
     &      (aword(3) .ne. 'fact')   .and.
     &      (aword(3) .ne. 'gcd')    .and.
     &      (aword(3) .ne. 'lcm')    .and.
     &      (aword(3) .ne. 'max')    .and.
     &      (aword(3) .ne. 'min')    .and.
     &      (aword(3) .ne. 'mod')    .and.
     &      (aword(3) .ne. 'perm')   .and.
     &      (aword(3) .ne. 'ran')    .and.
     &      (aword(3) .ne. 'sign')   .and.
     &      (aword(3) .ne. '^'))     then
          write (   6, 8135) ainput, ninput, aword(3)
          write (iout, 8135) ainput, ninput, aword(3)
          go to 999
        endif
      endif

c.... Find the number base and largest number of characters in the ASCII
c....   representation of the integers.

      idmaxpar = idmax
      if (amode .eq. 'oct') then
       nbase = 8
       idmaxx = 24
       if (idmaxpar .eq. 13) idmaxx = 16
      elseif (amode .eq. 'dec') then
       nbase = 10
       idmaxx = 20
       if (idmaxpar .eq. 13) idmaxx = 14
      else
       nbase = 16
       idmaxx = 18
       if (idmaxpar .eq. 13) idmaxx = 12
      endif

c===============================================================================

c.... Find the first integer.

c.... Translate the input character string into machine integer format.

      call aptchai (aword(2), 1, lword(2), idmaxx, nbase,
     &              intm, nerra)

c.... Replace all upper case with lower case.

      achold = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
      achnew = 'abcdefghijklmnopqrstuvwxyz'

      awordx = aword(2)
      call aptchrp (awordx, 1, lword(2), achold, achnew, 26, nerra)

c.... Translate the machine integer word into a character string.

      awordy = ' '
      call aptchia (intm, nbase, awordy, lword(2), ibeg, ncharx, nerra)
cbugc____ DEBUG begins.
cbug 9801 format ('aword(2)=',a40 /
cbug     &        'awordx  =',a40 /
cbug     &        'awordy  =',a40 )
cbug      write (   6, 9801) aword(2), awordx, awordy
cbug      write (iout, 9801) aword(2), awordx, awordy
cbugc____ DEBUG ends.

      if (awordx .ne. awordy) then
        write (   6, 8230) ainput, ninput, aword(2)
        write (iout, 8230) ainput, ninput, aword(2)
        go to 999
      endif

 8200 format ('  icalc ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Word 2 can not be interpreted as a hex integer:  ',a)
 8210 format ('  icalc ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Word 2 can not be interpreted as a dec integer:  ',a)
 8220 format ('  icalc ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Word 2 can not be interpreted as an oct integer:  ',a)
 8230 format ('  icalc ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Word 2 can not be interpreted as an integer:  ',a )
 8240 format ('  icalc ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Word 2 is too big.')

      if ((aword(2) .gt. 'ffffffffffffffff') .and.
     &    (lword(2) .ge. idmaxx)     .and.
     &    (amode .eq. 'hex'))        then
        write (   6, 8200) ainput, ninput, aword(2)
        write (iout, 8200) ainput, ninput, aword(2)
        go to 999
      endif

      if ((amode .eq. 'dec')            .and.
     &    (lword(2) .ge. idmaxx)        .and.
     &    (aword(2) .gt. '9223372036854775807')) then
        write (   6, 8210) ainput, ninput, aword(2)
        write (iout, 8210) ainput, ninput, aword(2)
        go to 999
      endif

      if ((aword(2) .gt. '1777777777777777777777') .and.
     &    (lword(2) .ge. idmaxx)        .and.
     &    (amode .eq. 'oct'))           then
        write (   6, 8220) ainput, ninput, aword(2)
        write (iout, 8220) ainput, ninput, aword(2)
        go to 999
      endif

      if (nerra .ne. 0) then
        write (   6, 8230) ainput, ninput, aword(2)
        write (iout, 8230) ainput, ninput, aword(2)
        go to 999
      endif
cbugc____ DEBUG begins.
cbug 9802 format ('intm=',i12,'  iabs (intm)=',i12)
cbug      intmabs = iabs (intm)
cbug      write (   6, 9802) intm, intmabs
cbug      write (iout, 9902) intm, intmabs
cbugc____ DEBUG ends.

      if (iabs (intm) .gt. 9223372036854775807) then
        write (   6, 8240) ainput, ninput, aword(2)
        write (iout, 8240) ainput, ninput, aword(2)
        go to 999
      endif

      if ((intm .lt. 0.0)          .and.
     &    (iabs (intm) .eq. intm)) then
        write (   6, 8240) ainput, ninput, aword(2)
        write (iout, 8240) ainput, ninput, aword(2)
        go to 999
      endif

      call aptbite (intm, nbitm, nbitm, intmex, nerra)

 8250 format ('M (',a3,')    = ',i22,' dec' /
     &        '             ',o22,' oct' /
     &        '             ',z22,' hex' )
 8260 format ('binary = ' / 16(1x,4i1))

      write (   6, 8250) amode, intm, intm, intm
      write (iout, 8250) amode, intm, intm, intm
      if (abind .eq. 'bin') then
        write (   6, 8260) (intmex(i), i = 1, nbitm)
        write (iout, 8260) (intmex(i), i = 1, nbitm)
      endif

      if (nword .eq. 2) go to 999

c===============================================================================

c.... Find the second integer.

      call aptchai (aword(4), 1, lword(4), idmaxx, nbase,
     &                intn, nerra)

      awordx = aword(4)
      call aptchrp (awordx, 1, lword(4), achold, achnew, 26, nerra)

      awordy = ' '
      call aptchia (intn, nbase, awordy, lword(4), ibeg, ncharx, nerra)
cbugc____ DEBUG begins.
cbug 9901 format ('aword(4)=',a40 /
cbug     &        'awordx  =',a40 /
cbug     &        'awordy  =',a40 )
cbug      write (   6, 9901) aword(4), awordx, awordy
cbug      write (iout, 9901) aword(4), awordx, awordy
cbugc____ DEBUG ends.

      if (awordx .ne. awordy) then
        write (   6, 8330) ainput, ninput, aword(4)
        write (iout, 8330) ainput, ninput, aword(4)
        go to 999
      endif

 8300 format ('  icalc ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Word 4 can not be interpreted as a hex integer:  ',a)
 8310 format ('  icalc ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Word 4 can not be interpreted as a dec integer:  ',a)
 8320 format ('  icalc ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Word 4 can not be interpreted as an oct integer:  ',a)
 8330 format ('  icalc ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Word 4 can not be interpreted as an integer:  ',a )
 8340 format ('  icalc ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Word 4 is too big.')

      if ((aword(4) .gt. 'ffffffffffffffff') .and.
     &    (lword(4) .ge. idmaxx)     .and.
     &    (amode .eq. 'hex'))        then
        write (   6, 8300) ainput, ninput, aword(4)
        write (iout, 8300) ainput, ninput, aword(4)
        go to 999
      endif

      if ((amode .eq. 'dec')            .and.
     &    (lword(4) .ge. idmaxx)        .and.
     &    (aword(4) .gt. '9223372036854775807')) then
        write (   6, 8310) ainput, ninput, aword(2)
        write (iout, 8310) ainput, ninput, aword(2)
        go to 999
      endif

      if ((aword(4) .gt. '1777777777777777777777') .and.
     &    (lword(4) .ge. idmaxx)        .and.
     &    (amode .eq. 'oct'))            then
        write (   6, 8320) ainput, ninput, aword(4)
        write (iout, 8320) ainput, ninput, aword(4)
        go to 999
      endif

      if (nerra .ne. 0) then
        write (   6, 8330) ainput, ninput, aword(4)
        write (iout, 8330) ainput, ninput, aword(4)
        go to 999
      endif
cbugc____ DEBUG begins.
cbug 9902 format ('intn=',i12,'  iabs (intn)=',i12)
cbug      intnabs = iabs (intn)
cbug      write (   6, 9902) intn, intnabs
cbug      write (iout, 9902) intn, intnabs
cbugc____ DEBUG ends.

      if (iabs (intn) .gt. 9223372036854775807) then
        write (   6, 8340) ainput, ninput, aword(4)
        write (iout, 8340) ainput, ninput, aword(4)
        go to 999
      endif

      if ((intn .lt. 0.0)          .and.
     &    (iabs (intn) .eq. intn)) then
        write (   6, 8340) ainput, ninput, aword(2)
        write (iout, 8340) ainput, ninput, aword(2)
        go to 999
      endif

      call aptbite (intn, nbitm, nbitm, intnex, nerra)

 8350 format ('N (',a3,')    = ',i22,' dec' /
     &        '             ',o22,' oct' /
     &        '             ',z22,' hex' )

      write (   6, 8350) amode, intn, intn, intn
      write (iout, 8350) amode, intn, intn, intn
      if (abind .eq. 'bin') then
        write (   6, 8260) (intnex(i), i = 1, nbitm)
        write (iout, 8260) (intnex(i), i = 1, nbitm)
      endif

c=======================================================================********

c.... Do the specified integer arithmetic.

 8400 format ('  icalc ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Cannot do modulo < 2.')
 8402 format ('M and N have a common factor,' /
     &        '  so  M has no order or inverse.')
 8404 format ('Order   of ',i22,' mod',i20,' =',i20 /
     &        'Inverse of ',i22,' mod',i20,' =',i20 )
 8410 format ('  icalc WARNING.  Reading ',a40,' line ',i5,'.' /
     &  '  Integer to a negative integer power truncates to zero.')
 8420 format ('  icalc ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Cannot divide by zero.')
 8430 format ('  icalc WARNING.  Reading ',a40,' line ',i5,'.' /
     &  '  Integer divide by larger integer truncates to zero.')
 8435 format ('  icalc WARNING.  Reading ',a40,' line ',i5,'.' /
     &  '  Cannot find factorial of a negative integer.')
 8436 format ('  icalc WARNING.  Reading ',a40,' line ',i5,'.' /
     &  '  Cannot find permutations of a negative integer.')
 8437 format ('  icalc WARNING.  Reading ',a40,' line ',i5,'.' /
     &  '  Cannot find combinations of a negative integer.')
 8438 format ('  icalc WARNING.  Reading ',a40,' line ',i5,'.' /
     &  '  2nd arg is not in range from 0 to 1st arg.')
 8460 format ('  icalc ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Integer overflow.',1pe22.14)
 8462 format ('  icalc ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Integer overflow.  Exponent of 10 =',1pe22.14)
 8465 format ('  icalc ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Cannot find greatest common divisor of args.')
 8470 format ('  icalc ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Cannot find least common multiple of args.')

      fintm = intm
      fintn = intn
      intr  = -999999999
      fintr = -1.e99

      if (aword(3) .eq. '+') then
        intr = intm + intn
        intk = intr - intn
        fintr = fintm + fintn
      elseif (aword(3) .eq. '-') then
        intr = intm - intn
        intk = intr + intn
        fintr = fintm - fintn
      elseif (aword(3) .eq. '*') then
        fintr = fintm * fintn
        fexp = log10 (abs (fintm)) + log10 (abs (fintn))
        if (fexp .gt. idmax) then
          write (   6, 8462) ainput, ninput, fexp
          write (iout, 8462) ainput, ninput, fexp
          go to 999
        endif
        intr = intm * intn
        if (intn .eq. 0) then
          intk = intm
        else
          intk = intr / intn
        endif
      elseif (aword(3) .eq. '/') then
        if (intn .eq. 0) then
          write (   6, 8420) ainput, ninput
          write (iout, 8420) ainput, ninput
          go to 999
        elseif (iabs (intn) .gt. iabs (intm)) then
          write (   6, 8430) ainput, ninput
          write (iout, 8430) ainput, ninput
          go to 999
        else
          fintr = fintm / fintn
          intk  = intm
          intr  = intm / intn
        endif
      elseif ((aword(3) .eq. '^')   .or.
     &        (aword(3) .eq. '**')) then
        if (intn .eq. 0) then
          intr = 1
          intk = intm
        elseif (intn .lt. 0) then
          write (   6, 8410) ainput, ninput
          write (iout, 8410) ainput, ninput
          go to 999
        else
          farg = abs (intm)
          fpow = intn
          fexp = abs (fpow) * log10 (farg)
          if (fexp .gt. idmax) then
            write (   6, 8462) ainput, ninput, fexp
            write (iout, 8462) ainput, ninput, fexp
            go to 999
          endif
          intr = intm**intn
          fintr = intr
          intk = nint ((abs (fintr))**(1.0 / abs (fintn)))
          if (mod (intn, 2) .eq. 0) then
            intk = isign (intk, intm)
          else
            intk = isign (intk, intr)
          endif
        endif
        fintr = fintm**intn
      elseif (aword(3) .eq. 'abs') then
        intr = intm * iabs (intn)
        intk = intr / iabs (intn)
        fintr = fintm * abs (fintn)
      elseif (aword(3) .eq. 'ran') then
        intk = intm
        call aptrins (intm, intn, intr)
        fintr = intr
      elseif (aword(3) .eq. 'sign') then
        intk = intm
        intr = isign (intm, intn)
        fintr = sign (fintm, fintn)
      elseif (aword(3) .eq. 'max') then
        intk = intm
        intr = max0 (intm, intn)
        fintr = amax1 (fintm, fintn)
      elseif (aword(3) .eq. 'min') then
        intk = intm
        intr = min0 (intm, intn)
        fintr = amin1 (fintm, fintn)
      elseif (aword(3) .eq. 'mod') then
        if (intn .lt. 2) then
          write (   6, 8400) ainput, ninput
          write (iout, 8400) ainput, ninput
          go to 999
        else
          intk = intm
          intr = mod (intm, intn)
          if (intr .lt. 0) intr = intr + intn
          fintr = amod (fintm, fintn)
          if (fintr .lt. 0.0) fintr = fintr + fintn

          call aptmord (intr, intn, mord, minv, nerra)

          if (nerra .eq. -1) then
            write (   6, 8402)
            write (iout, 8402)
          elseif (nerra .eq. 0) then
            write (   6, 8404) intm, intn, mord,
     &                         intm, intn, minv
            write (iout, 8404) intm, intn, mord,
     &                         intm, intn, minv
          endif

        endif
      elseif (aword(3) .eq. 'fact') then
        if (intn .eq. 0) then
          intk = intm
          intr = intm
          fintr = fintm
        elseif (intn .lt. 0) then
          write (   6, 8435) ainput, ninput
          write (iout, 8435) ainput, ninput
          go to 999
        else
          intr = intm
          fintr = fintm
          do 430 n = 1, intn
            fn    = n
            fintr = fintr * fn
            if (abs (fintr) .gt. 10.0**idmax) then
              fexp = log10 (abs (fintr))
              write (   6, 8462) ainput, ninput, fexp
              write (iout, 8462) ainput, ninput, fexp
              go to 999
            endif
            intr  = intr * n
  430     continue
          intk = intr
          do 435 n = 1, intn
            intk = intk / n
  435     continue
        endif
      elseif (aword(3) .eq. 'comp.') then
        awordx = 'comp'
        call aptbitb (awordx, intn, intn, 64, intr, nerra)
        intr = intm * intr
        fintr = intr
        intk = intm
      elseif ((aword(3) .eq. '.xnor.') .or.
     &        (aword(3) .eq. '.eqv.')) then
        awordx = 'eqv'
        call aptbitb (awordx, intm, intn, 64, intr, nerra)
        fintr = intr
        intk = intm
      elseif ((aword(3) .eq. '.and.')  .or.
     &        (aword(3) .eq. '.int.')) then
        awordx = 'and'
        call aptbitb (awordx, intm, intn, 64, intr, nerra)
        fintr = intr
        intk = intm
      elseif (aword(3) .eq. '.nand.') then
        awordx = 'nand'
        call aptbitb (awordx, intm, intn, 64, intr, nerra)
        fintr = intr
        intk = intm
      elseif (aword(3) .eq. '.nor.') then
        awordx = 'nor'
        call aptbitb (awordx, intm, intn, 64, intr, nerra)
        fintr = intr
        intk = intm
      elseif (aword(3) .eq. '.not.') then
        awordx = 'not'
        call aptbitb (awordx, intm, intn, 64, intr, nerra)
        fintr = intr
        intk = intm
      elseif ((aword(3) .eq. '.or.')  .or.
     &        (aword(3) .eq. '.un.')) then
        awordx = 'or'
        call aptbitb (awordx, intm, intn, 64, intr, nerra)
        fintr = intr
        intk = intm
      elseif (aword(3) .eq. '.xor.') then
        awordx = 'xor'
        call aptbitb (awordx, intm, intn, 64, intr, nerra)
        fintr = intr
        intk = intm
      elseif (aword(3) .eq. 'perm') then
        if (intm .lt. 0) then
          write (   6, 8436) ainput, ninput
          write (iout, 8436) ainput, ninput
          go to 999
        endif
        if ((intn .lt. 0) .or. (intn .gt. intm)) then
          write (   6, 8438) ainput, ninput
          write (iout, 8438) ainput, ninput
          go to 999
        endif
        intk = intm
        call aptperf (intm, intn, tol, nperm, perm, nerra)
        if (nerra .ne. 0) then
          write (   6, 8460) ainput, ninput, perm
          write (iout, 8460) ainput, ninput, perm
          go to 999
        endif
        intr  = nperm
        fintr = perm
      elseif (aword(3) .eq. 'comb') then
        if (intm .lt. 0) then
          write (   6, 8437) ainput, ninput
          write (iout, 8437) ainput, ninput
          go to 999
        endif
        if ((intn .lt. 0) .or. (intn .gt. intm)) then
          write (   6, 8438) ainput, ninput
          write (iout, 8438) ainput, ninput
          go to 999
        endif
        intk = intm
        call aptcomf (intm, intn, tol, ncomb, comb, nerra)
        if (nerra .ne. 0) then
          write (   6, 8460) ainput, ninput, comb
          write (iout, 8460) ainput, ninput, comb
          go to 999
        endif
        intr  = ncomb
        fintr = comb
      elseif (aword(3) .eq. 'gcd') then
        intk      = intm
        intarg(1) = intm
        intarg(2) = intn
        call aptcmad (intarg, 2, intr, ijunk, nerra)
        if ((nerra .ne. 0) .and. (nerra .ne. 4)) then
          write (   6, 8465) ainput, ninput
          write (iout, 8465) ainput, ninput
          go to 999
        endif
        fintr = intr
      elseif (aword(3) .eq. 'lcm') then
        intk      = intm
        intarg(1) = intm
        intarg(2) = intn
        call aptcmad (intarg, 2, ijunk, intr, nerra)
        if (nerra .ne. 0) then
          write (   6, 8470) ainput, ninput
          write (iout, 8470) ainput, ninput
          go to 999
        endif
        fintr = intr
      endif

      call aptbite (intr, nbitm, nbitm, intrex, nerra)

c===============================================================================

c.... Print the value of the result.

 8440 format ('M ',a6,' N = ',i22,' dec' /
     &        '             ',o22,' oct' /
     &        '             ',z22,' hex' )
 8450 format ('Check     ',0pf25.3,1pe22.14)

      write (   6, 8440) aword(3), intr, intr, intr
      write (iout, 8440) aword(3), intr, intr, intr
      if (abind .eq. 'bin') then
        write (   6, 8260) (intrex(i), i = 1, nbitm)
        write (iout, 8260) (intrex(i), i = 1, nbitm)
      endif
      write (   6, 8450) fintr, fintr
      write (iout, 8450) fintr, fintr

cbugc____ DEBUG begins.
cbugc.... Print the check value of M.
cbug
cbug 8196 format ('M (check)=',i16,' dec  ',z16,' hex  ',o22,' oct)
cbug
cbug      write (   6, 8196) intk, intk, intk
cbug      write (iout, 8196) intk, intk, intk
cbugc____ DEBUG ends.

 8500 format ('  icalc ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Calculation may have overflowed or truncated.')

      if (intk .ne. intm) then
        write (   6, 8500) ainput, ninput
        write (iout, 8500) ainput, ninput
        go to 999
      endif

      if ((intm .ge. 0)            .and.
     &    (intn .ge. 0)            .and.
     &    (aword(3) .ne. '-')      .and.
     &    (aword(3) .ne. 'comp.')  .and.
     &    (aword(3) .ne. '.nand.') .and.
     &    (aword(3) .ne. '.nor.')  .and.
     &    (aword(3) .ne. '.xnor.') .and.
     &    (intr .lt. 0))           then
        write (   6, 8500) ainput, ninput
        write (iout, 8500) ainput, ninput
        go to 999
      endif

c===============================================================================

  999 return

c.... End of subroutine icalc.        (+1 line)
      end
