      subroutine incr

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  incr     Updated     2004 November 23 13:30.
c               incr     Originated  1994 August 17 15:00.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To increment a blank-delimited character string the same way
c               object names are incremented for creating familys of objects.
c
c     Logic:    Entry points:  incr.
c incr          Called by:  helpall, main.
c
c incr          Calls:  incrsubs, varfind.
c
c     Biblio:   ?
c
c     Glossary:
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

      common /aincr/ lanamex(6)       ! Number of characters in anamex.
      common /aincr/ anamex(6)        ! String name.
      character*80   anamex           ! String name.
      character*80   anamexx          ! String name.

c=======================================================================********

c.... Input line:  increment [help]

 8110 format ('  Command "increment":  acceptable input lines',
     &  ' include:' //
     &  '  "increment [help]"  Display this message.' //
     &  '  "increment STRING"' /
     &  '     Increment STRING by 1 character.' /
     &  '  "increment STRING INC [NUMSTR|2]"' /
     &  '     Create a family of NUMSTR blank-delimited character',
     &  ' strings,' /
     &  '     by incrementing the preceding string by INC',
     &  ' characters,' /
     &  '     starting with string STRING.' //
     &  '  Note:  STRING may not have more than 24 characters.' //
     &  '  Synonyms:  [increment, incr], [help, h].' )

      if ((nword .eq. 1) .or.
     &   ((nword .eq. 2) .and.
     &   ((aword(2) .eq. 'help') .or.
     &    (aword(2) .eq. 'h')))) then
        write (   6, 8110)
        write (iout, 8110)
        go to 999
      endif

c=======================================================================********

c.... Input line:  increment STRING [INC|1] [NUMSTR|2]

 8120 format ('  incr ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Not 4 words on "increment" line:  ',i3)

 8130 format ('  incr ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  STRING has more than 24 characters:  ',i3)

      if (nword .eq. 2) then
        nword = 3
        iword(3) = 1
        mtype(3) = 2
      endif

      if (nword .eq. 3) then
        nword = 4
        iword(4) = 2
        mtype(4) = 2
      endif

      if (nword .ne. 4) then
        write (   6, 8120) ainput, ninput, nword
        write (iout, 8120) ainput, ninput, nword
        go to 999
      endif

      if (lword(2) .gt. 24) then
        write (   6, 8130) ainput, ninput, lword(2)
        write (iout, 8130) ainput, ninput, lword(2)
        go to 999
      endif

 8140 format ('  incr ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Word INC is zero.')
 8150 format ('  incr ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Word INC is not an integer or integer variable:  ',a)

      call varfind (3, 3)

      if (mtype(3) .eq. 2) then
        inc = iword(3)
        if (inc .eq. 0) then
          write (   6, 8140) ainput, ninput
          write (iout, 8140) ainput, ninput
          go to 999
        endif
      else
        write (   6, 8150) ainput, ninput, aword(3)
        write (iout, 8150) ainput, ninput, aword(3)
        go to 999
      endif

 8160 format ('  incr ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Word NUMSTR is not a positive integer:  ',a)
 8170 format ('  incr ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Word NUMSTR is not an integer or integer variable:  ',a)

      call varfind (4, 4)

      if (mtype(4) .eq. 2) then
        numstr = iword(4)
        if (numstr .lt. 1) then
          write (   6, 8160) ainput, ninput, aword(4)
          write (iout, 8160) ainput, ninput, aword(4)
          go to 999
        endif
      else
        write (   6, 8170) ainput, ninput, aword(4)
        write (iout, 8170) ainput, ninput, aword(4)
        go to 999
      endif

c.... See if the string names can be generated uniquely.

 8180 format ('  incr ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Can not generate',i5,' string names from:  ',a)

      anamex(1)  = aword(2)
      lanamex(1) = lword(2)
      inctot     = inc * (numstr - 1)

      call incrsubs (inctot, anamex, 1, lanamex(1), nerra)

      if (nerra .ne. 0) then
        write (   6, 8180) ainput, ninput, numstr, aword(2)
        write (iout, 8180) ainput, ninput, numstr, aword(2)
        go to 999
      endif

c.... Create the incremented blank-delimited strings.

      nn         = 1
      anamex(1)  = aword(2)           ! Initial string name.
      lanamex(1) = lword(2)           ! Initial string length.
      anamexx    = anamex(1)          ! Initial string name.
      lanamexx   = lanamex(1)         ! Initial string length.

 8190 format ('Strings:', / a / a / a / a / a / a )

      do 190 nst = 1, numstr          ! Loop over the new strings.
cbugc***DEBUG begins.
cbug 9190 format ('incr DEBUG.  nst = ',i3,'  lanamex = ',i3 /
cbug     &  'anamex = <',a,'>')
cbug      write (   6, 9190) nst, lanamex(nn), anamex(nn)
cbug      write (iout, 9190) nst, lanamex(nn), anamex(nn)
cbugc***DEBUG ends.

        if (nn .eq. 6) then
          write (   6, 8190) (anamex(n), n = 1, 6)
          write (iout, 8190) (anamex(n), n = 1, 6)
          nn = 0
        endif

        if (nst .eq. numstr) go to 190

c....   Find the next string name, by incrementing by inc.

        nn = nn + 1
        anamex(nn)  = anamexx         ! Preceding string name.
        lanamex(nn) = lanamexx        ! Preceding string name.

        call incrsubs (inc, anamex(nn), 1, lanamex(nn), nerra)

        anamexx    = anamex(nn)
        lanamexx   = lanamex(nn)

  190 continue                        ! End of loop over the new strings.

      if (nn .ne. 0) then
        write (   6, 8190) (anamex(n), n = 1, nn)
        write (iout, 8190) (anamex(n), n = 1, nn)
      endif

  999 return

c.... End of subroutine incr.         (+1 line)
      end
