      subroutine meshfind (k, l, m, np)

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  meshfind Updated     2005 March 9 14:40.
c               meshfind Originated  1995 July 20 12:40.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To find any mesh point with the mesh indices k, l and m,
c               and return the index of the point.
c
c     Logic:    Entry points:  meshfind.
c meshfind      Called by:  mesh, meshline, meshrlxb, meshrlxm, meshtest.
c               Calls:  (none).
c
c     Biblio:   ?
c
c     Glossary:
c
c     k, l, m   Input    Mesh indices.
c
c     np        Output   Index of mesh point.  0 if none.
c                          -1 if input indices are bad.
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

c.... Initialize.

      np = 0

      if ((k .lt. 1) .or. (k .gt. kmax)  .or.
     &    (l .lt. 1) .or. (l .gt. lmax)  .or.
     &    (m .lt. 1) .or. (m .gt. mmax)) then
        np = -1
        go to 999
      endif

c.... Find any point with the specified indices k, l and m.

      do 120 n = 1, npoints          ! Loop over points.
        if (apoint(n) .eq. ' ') go to 120

        if ((kpoint(n) .eq. k)  .and.
     &      (lpoint(n) .eq. l)  .and.
     &      (mpoint(n) .eq. m)) then

          np = n

          go to 999

        endif

  120 continue                        ! End of loop over points.

  999 return

c.... End of subroutine meshfind.     (+1 line)
      end
