      subroutine ptstore (nrep, n)

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  ptstore  Updated     1994 July 21 16:40.
c               ptstore  Originated  1994 March 11 15:50.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To find the index in the point array in which to store the
c               point being created, with the name aword(2).
c
c     Logic:    Entry points:  ptstore.
c ptstore       Called by:  mesh, point, ptoper.
c
c ptstore       Calls:  pout.
c
c     Biblio:   ?
c
c     Glossary:
c
c     aword(2)  store.h  The name of the point for which an storage index is
c                          to be found.
c
c     n         Output   0 if point array is full.  No room for a new point.
c                          Positive if the index where the new point is to
c                          be stored.
c
c     nrep      Output   0 if point name is new, 1 if an old point with the
c                          same name is being replaced.
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

      character*8 amount              ! Amount of output data.

      n = 0

c.... See if the point name already exists.

 8110 format ('  WARNING:  replacing existing point:  ',a)

      nrep = 0

      do 110 np = 1, npoints
        if (aword(2) .eq. apoint(np)) then
          nrep = 1
          n    = np
          write (   6, 8110) apoint(np)
          write (iout, 8110) apoint(np)
          amount = 'minimum'
          call pout (np, np, amount)
          go to 999
        endif
  110 continue

c.... See if a null point can be replaced.

      do 120 np = 1, npoints
        if (apoint(np) .eq. ' ') then
          n = np
          go to 999
        endif
  120 continue

c.... See if the maximum number of points has been exceeded.

 8130 format ('  ptstore ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Number of points exceeds limit ',i5)

      if ((npoints + 1) .gt. npointm) then
        write (   6, 8130) ainput, ninput, npointm
        write (iout, 8130) ainput, ninput, npointm
        n = 0
        go to 999
      endif

c.... Add a new point at the end of the list.

      npoints = npoints + 1

      n = npoints

c=======================================================================********

  999 return

c.... End of subroutine ptstore.      (+1 line)
      end
