      subroutine subsrepl

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  subsrepl Updated     2004 November 19 15:50.
c               subsrepl Originated  2002 October 25 13:40.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To replace each variable subscript with its integer equivalent.
c
c     Logic:    Entry points:  subsrepl.
c subsrepl      Called by:  main.
c
c subsrepl      Calls:  aptchia, aptchmv, aptsubb, aptsubm, varout.
c
c     Biblio:   ?
c
c     Glossary: See store.h.
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

c.... Local variables.

c.... Subscript data.

      character*80 asubx              ! ASCII equivalent of integer subscript.

      do 180 nw = 1, nword            ! Loop over command words.

        lwords(nw) = lword(nw)

        if (mtype(nw) .ne. 1) go to 180  ! Word has no subscript.
        if (lword(nw) .le. 3) go to 180  ! Word has no subscript.
cbugc***DEBUG begins.
cbug 9701 format ('subsrepl DEBUG 1.  nw =',i3,'  lword =',i3,
cbug     &  '  aword = ',a)
cbug      write (   6, 9701) nw, lword(nw), aword(nw)
cbug      write (iout, 9701) nw, lword(nw), aword(nw)
cbugc***DEBUG ends.

        call aptsubm (aword(nw), 1, lword(nw), iamax, idmax, iemax,
     &    '(', ',', ')', 16,
     &          astem, istem, fstem, mstem, lstem,
     &    nsub, asub,  isub,  fsub,  msub,  lsub, nerr)
cbugc***DEBUG begins.
 9761 format ('subsrepl DEBUG 1A.  aptsubm nerr =',i3)
cbug      write (   6, 9761) nerr
cbug      write (iout, 9761) nerr
cbugc***DEBUG ends.

        if (nerr .ne. 0) go to 180    ! Can not separate word.
        if (nsub .eq. 0) go to 180    ! Word has no subscripts.

c....   Replace any ASCII subscript with its integer equivalent, in ASCII.

        do n = 1, nsub                ! Loop over subscripts.
cbugc***DEBUG begins.
cbug 9777 format ('astem = <',a,'>' / 'asub = <',a,'>')
cbug 9778 format ('msub = ',i2,'  lsub = ',i2 /
cbug     &  'isub = ',i22 /
cbug     &  'fsub = ',1pe22.14 )
cbug        write (   6, 9777) astem, asub(n)
cbug        write (iout, 9777) astem, asub(n)
cbug        write (   6, 9778) msub(n), lsub(n), isub(n), fsub(n)
cbug        write (iout, 9778) msub(n), lsub(n), isub(n), fsub(n)
cbugc***DEBUG ends.
cbugc***DEBUG begins.
cbug 9702 format ('subsrepl DEBUG 2.  nw =',i3,'  lword =',i3,
cbug     &  '  aword = <',a,'>')
cbug      write (   6, 9702) nw, lword(nw), aword(nw)
cbug      write (iout, 9702) nw, lword(nw), aword(nw)
cbugc***DEBUG ends.

          if     (msub(n) .eq. 2) then  ! Subscript is already an integer.

c....       Find ASCII equivalent of subscript, put into asub.

            asubx   = ' '
            call aptchia (isub(n), 10, asubx, 80,
     &                          ibeg, lsub(n), nerr)
            nchar = 1

            call aptchmv (asubx, ibeg, lsub(n),
     &                    asub(n), nchar, nerr)

          elseif (msub(n) .eq. 1) then  ! Subscript is ASCII.

c....       Find any integer value of subscript.

            do nvar = 1, nvars        ! Loop over named variables.
cbugc***DEBUG begins.
cbug 9703 format ('subsrepl DEBUG 3.  asub = <',a,'>  nvar = ',i3,
cbug     &  '  avarbl = <',a,'>')
cbug      write (   6, 9703) asub(n), nvar, avarbl(nvar)
cbug      write (iout, 9703) asub(n), nvar, avarbl(nvar)
cbugc***DEBUG ends.
              if (asub(n) .eq. avarbl(nvar)) then  ! Found variable.
cbugc***DEBUG begins.
cbug 9704 format ('subsrepl DEBUG 4.  asub = <',a,'>  nvar = ',i3,
cbug     &  '  avarbl = <',a,'>')
cbug      write (   6, 9704) asub(n), nvar, avarbl(nvar)
cbug      write (iout, 9704) asub(n), nvar, avarbl(nvar)
cbugc***DEBUG ends.
                call varout (nvar, nvar)

                if (mvar(nvar) .eq. 2) then  ! Subscript has integer equivalent.
cbugc***DEBUG begins.
cbug 9705 format ('subsrepl DEBUG 5.  asub = <',a,'>  nvar = ',i3,
cbug     &  '  avarbl = <',a,'>')
cbug      write (   6, 9705) asub(n), nvar, avarbl(nvar)
cbug      write (iout, 9705) asub(n), nvar, avarbl(nvar)
cbugc***DEBUG ends.
                  isub(n) = ivar(nvar)
                  msub(n) = 2

c....             Replace ASCII variable name with ASCII equivalent of integer.

                  asubx   = ' '
                  call aptchia (isub(n), 10, asubx, 80,
     &                          ibeg, lsub(n), nerr)
                  nchar = 1

                  call aptchmv (asubx, ibeg, lsub(n),
     &                          asub(n), nchar, nerr)
                endif                 ! Replaced integer with ASCII.
              endif                   ! Found variable.
            enddo                     ! End of loop over named variables.
          endif                       ! Subscript is ASCII.
cbugc***DEBUG begins.
cbug 9708 format ('subsrepl DEBUG 8.  nw =',i3,'  lword =',i3,
cbug     &  '  aword = ',a)
cbug      write (   6, 9708) nw, lword(nw), aword(nw)
cbug      write (iout, 9708) nw, lword(nw), aword(nw)
cbugc***DEBUG ends.
        enddo                         ! End of loop over subscripts.

c....   Rebuild aword with all integer subscripts specified.

        call aptsubb (astem, lstem, nsub, asub, lsub, 80, '(', ',', ')',
     &                aword(nw), lword(nw), nerr)

cbugc***DEBUG begins.
cbug 9709 format ('subsrepl DEBUG 9.  nw =',i3,'  lword =',i3,
cbug     &  '  aword = ',a)
cbug      write (   6, 9709) nw, lword(nw), aword(nw)
cbug      write (iout, 9709) nw, lword(nw), aword(nw)
cbugc***DEBUG ends.
 
  180 continue                        ! End of loop over command words.

  999 return

c.... End of subroutine subsrepl.     (+1 line)
      end
