      subroutine synonym

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  synonym  Updated     2006 July 14 14:30.
c               synonym  Originated  1994 September 20 17:10.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To display the synonyms, symbols and aliases for all commands
c               and key words, if any exist.
c
c     Logic:    Entry points:  synonym.
c synonym       Called by:  helpall, main.
c
c synonym       Calls:  alias, alout, symbol, symbout, synout.
c
c     Biblio:   ?
c
c     Glossary:
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

      character*1 afirst              ! Single character of SYNAME.
      character*1 afirst1             ! First character of asyn1(n).
      character*1 afirst2             ! First character of asyn2(n).

c=======================================================================********

c.... Input line:  synonym [help]

 8110 format (
     &  '  Command "synonym":  acceptable input lines include:' //
     &  '  "synonym [help]"  Display this message.' //
     &  '  "synonym all"     Display all synonyms.' //
     &  '  "synonym none"    Display all command words and key',
     &  ' words' /
     &  '     for which there is no preset synonym.' //
     &  '  "synonym SYNAME1 SYNAME2 SYNAME3 ..."' /
     &  '     Display the synonyms, symbols and aliases for each',
     &  ' listed word,' /
     &  '     or if a single character, all synonyms, symbols and',
     &  ' aliases' /
     &  '     beginning with that character (for "h", use "SYNAME2".' //
     &  '  Synonyms:  [help, h], [synonym, syn].')

      if ((nword .eq. 1) .or.
     &   ((nword .eq. 2) .and.
     &   ((aword(2) .eq. 'help') .or.
     &    (aword(2) .eq. 'h')))) then
        write (   6, 8110)
        write (iout, 8110)
        go to 999
      endif

c=======================================================================********

c.... Initialize.  Includes all commands, key words, options, comment definers.

      if (nword .eq. 0) then

        n = 0

        n = n + 1
        asyn1(n)   = '!'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = '"'
        asyn2(n)   = ''''
        n = n + 1
        asyn1(n)   = '#'
        asyn2(n)   = 'undefined'
        asyncmd(n) = 'input'
        n = n + 1
        asyn1(n)   = '#'
        asyn2(n)   = '*'
        asyncmd(n) = 'comment'
        n = n + 1
        asyn1(n)   = '#'
        asyn2(n)   = '/'
        asyncmd(n) = 'comment'
        n = n + 1
        asyn1(n)   = '$'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = '%'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = '&'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = '*'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = '+'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = '-'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = '.'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = '.and.'
        asyn2(n)   = '.int.'
        n = n + 1
        asyn1(n)   = '.nand.'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = '.nor.'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = '.not.'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = '.or.'
        asyn2(n)   = '.un.'
        n = n + 1
        asyn1(n)   = '.xnor.'
        asyn2(n)   = '.eqv.'
        n = n + 1
        asyn1(n)   = '.xor.'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = '/'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = '/='
        asyn2(n)   = '.ne.'
        asyncmd(n) = 'if'
        n = n + 1
        asyn1(n)   = '/='
        asyn2(n)   = '=/'
        asyncmd(n) = 'if'
        n = n + 1
        asyn1(n)   = '0'
        asyn2(n)   = 'zero'
        asyncmd(n) = 'big'
        n = n + 1
        asyn1(n)   = ';'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = '<'
        asyn2(n)   = '.lt.'
        asyncmd(n) = 'if'
        n = n + 1
        asyn1(n)   = '<='
        asyn2(n)   = '.le.'
        asyncmd(n) = 'if'
        n = n + 1
        asyn1(n)   = '<='
        asyn2(n)   = '=<'
        asyncmd(n) = 'if'
        n = n + 1
        asyn1(n)   = '='
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = '='
        asyn2(n)   = '.eq.'
        asyncmd(n) = 'if'
        n = n + 1
        asyn1(n)   = '>'
        asyn2(n)   = '.gt.'
        asyncmd(n) = 'if'
        n = n + 1
        asyn1(n)   = '>='
        asyn2(n)   = '.ge.'
        asyncmd(n) = 'if'
        n = n + 1
        asyn1(n)   = '>='
        asyn2(n)   = '=>'
        asyncmd(n) = 'if'
        n = n + 1
        asyn1(n)   = '?'
        asyn2(n)   = 'undefined'
        asyncmd(n) = 'input'
        n = n + 1
        asyn1(n)   = '?'
        asyn2(n)   = 'random'
        asyncmd(n) = 'sort'
        n = n + 1
        asyn1(n)   = '^'
        asyn2(n)   = '**'
        n = n + 1
        asyn1(n)   = 'abs'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'accelerate'
        asyn2(n)   = 'accel'
        n = n + 1
        asyn1(n)   = 'acos'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'acosh'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'alias'
        asyn2(n)   = 'a'
        n = n + 1
        asyn1(n)   = 'alias'
        asyn2(n)   = 'al'
        n = n + 1
        asyn1(n)   = 'all'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'angle'
        asyn2(n)   = 'ang '
        n = n + 1
        asyn1(n)   = 'angles'
        asyn2(n)   = 'ang'
        asyncmd(n) = 'angles'
        n = n + 1
        asyn1(n)   = 'angles'
        asyn2(n)   = 'angle'
        asyncmd(n) = 'angles'
        n = n + 1
        asyn1(n)   = 'arc'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'area'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'arithmetic'
        asyn2(n)   = 'arith'
        n = n + 1
        asyn1(n)   = 'array'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'asin'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'asinh'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'atan'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'atan2'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'atanh'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'avg'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'axial'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'axis'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'axisym'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'base'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'big'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'bin'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'binary'
        asyn2(n)   = 'bin'
        asyncmd(n) = 'icalc, big'
        n = n + 1
        asyn1(n)   = 'bisect'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'block'
        asyn2(n)   = 'bl'
        n = n + 1
        asyn1(n)   = 'bound'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'brick'
        asyn2(n)   = 'br'
        n = n + 1
        asyn1(n)   = 'c'
        asyn2(n)   = 'C'
        asyncmd(n) = 'comment'
        n = n + 1
        asyn1(n)   = 'c++++'
        asyn2(n)   = 'C++++'
        asyncmd(n) = 'comment'
        n = n + 1
        asyn1(n)   = 'c----'
        asyn2(n)   = 'C----'
        asyncmd(n) = 'comment'
        n = n + 1
        asyn1(n)   = 'c....'
        asyn2(n)   = 'C....'
        asyncmd(n) = 'comment'
        n = n + 1
        asyn1(n)   = 'cartesian'
        asyn2(n)   = 'cart'
        n = n + 1
        asyn1(n)   = 'cartesian'
        asyn2(n)   = 'Cartesian'
        n = n + 1
        asyn1(n)   = 'cartesian'
        asyn2(n)   = 'rect'
        n = n + 1
        asyn1(n)   = 'cartesian'
        asyn2(n)   = 'rectangular'
        n = n + 1
        asyn1(n)   = 'cat'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'cartesian'
        asyn2(n)   = 'xyz'
        n = n + 1
        asyn1(n)   = 'cc'
        asyn2(n)   = 'CC'
        asyncmd(n) = 'comment'
        n = n + 1
        asyn1(n)   = 'cell'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'center'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'circle'
        asyn2(n)   = 'circ'
        n = n + 1
        asyn1(n)   = 'cluster'
        asyn2(n)   = 'cl'
        n = n + 1
        asyn1(n)   = 'col'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'comb'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'command'
        asyn2(n)   = 'c'
        asyncmd(n) = 'input'
        n = n + 1
        asyn1(n)   = 'command'
        asyn2(n)   = 'cmd'
        asyncmd(n) = 'input'
        n = n + 1
        asyn1(n)   = 'commands'
        asyn2(n)   = 'alph'
        n = n + 1
        asyn1(n)   = 'commands'
        asyn2(n)   = 'comm'
        n = n + 1
        asyn1(n)   = 'comp.'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'concentric'
        asyn2(n)   = 'conc'
        n = n + 1
        asyn1(n)   = 'cone'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'contfr'
        asyn2(n)   = 'cf'
        n = n + 1
        asyn1(n)   = 'coordinate'
        asyn2(n)   = 'coord'
        n = n + 1
        asyn1(n)   = 'coordinate'
        asyn2(n)   = 'cs'
        n = n + 1
        asyn1(n)   = 'coordinate'
        asyn2(n)   = 'sys'
        n = n + 1
        asyn1(n)   = 'coordinate'
        asyn2(n)   = 'system'
        n = n + 1
        asyn1(n)   = 'copy'
        asyn2(n)   = 'cp'
        n = n + 1
        asyn1(n)   = 'copy'
        asyn2(n)   = 'dup'
        n = n + 1
        asyn1(n)   = 'copy'
        asyn2(n)   = 'duplicate'
        n = n + 1
        asyn1(n)   = 'cos'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'cosh'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'cosine'
        asyn2(n)   = 'cos'
        asyncmd(n) = 'project'
        n = n + 1
        asyn1(n)   = 'cosine'
        asyn2(n)   = 'cos'
        asyncmd(n) = 'vector'
        n = n + 1
        n = n + 1
        asyn1(n)   = 'cross'
        asyn2(n)   = 'outer'
        n = n + 1
        asyn1(n)   = 'crt'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'curt'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'cute'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'cuts'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'cylinder'
        asyn2(n)   = 'cyl'
        n = n + 1
        asyn1(n)   = 'cylindrical'
        asyn2(n)   = 'cyl'
        asyncmd(n) = 'coordinate'
        n = n + 1
        asyn1(n)   = 'cylindrical'
        asyn2(n)   = 'cyl'
        asyncmd(n) = 'project'
        n = n + 1
        asyn1(n)   = 'c____'
        asyn2(n)   = 'C____'
        asyncmd(n) = 'comment'
        n = n + 1
        asyn1(n)   = 'data'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'dec'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'define'
        asyn2(n)   = 'def'
        n = n + 1
        asyn1(n)   = 'deg/rad'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'degrees'
        asyn2(n)   = 'deg'
        n = n + 1
        asyn1(n)   = 'degrees'
        asyn2(n)   = 'degree'
        n = n + 1
        asyn1(n)   = 'delete'
        asyn2(n)   = 'del'
        n = n + 1
        asyn1(n)   = 'delete'
        asyn2(n)   = 'remove'
        n = n + 1
        asyn1(n)   = 'delete'
        asyn2(n)   = 'rm'
        n = n + 1
        asyn1(n)   = 'delimiter'
        asyn2(n)   = 'delim'
        n = n + 1
        asyn1(n)   = 'delimiter'
        asyn2(n)   = 'delimit'
        n = n + 1
        asyn1(n)   = 'disk'
        asyn2(n)   = 'disc'
        n = n + 1
        asyn1(n)   = 'disk'
        asyn2(n)   = 'dk'
        n = n + 1
        asyn1(n)   = 'distance'
        asyn2(n)   = 'dist'
        asyncmd(n) = 'distance'
        n = n + 1
        asyn1(n)   = 'distance'
        asyn2(n)   = 'dist'
        asyncmd(n) = 'variable'
        n = n + 1
        asyn1(n)   = 'distance'
        asyn2(n)   = 'int'
        asyncmd(n) = 'distance'
        n = n + 1
        asyn1(n)   = 'distance'
        asyn2(n)   = 'inter'
        asyncmd(n) = 'distance'
        n = n + 1
        asyn1(n)   = 'distance'
        asyn2(n)   = 'intersect'
        asyncmd(n) = 'distance'
        n = n + 1
        asyn1(n)   = 'dms'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'do'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'dot'
        asyn2(n)   = 'inner'
        n = n + 1
        asyn1(n)   = 'duplicate'
        asyn2(n)   = 'copy'
        n = n + 1
        asyn1(n)   = 'duplicate'
        asyn2(n)   = 'cp'
        n = n + 1
        asyn1(n)   = 'duplicate'
        asyn2(n)   = 'dup'
        n = n + 1
        asyn1(n)   = 'ebase'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'edge'
        asyn2(n)   = 'side'
        asyncmd(n) = 'trig'
        n = n + 1
        asyn1(n)   = 'ellipsoid'
        asyn2(n)   = 'el'
        n = n + 1
        asyn1(n)   = 'ellipsoid'
        asyn2(n)   = 'ell'
        n = n + 1
        asyn1(n)   = 'ellipsoid'
        asyn2(n)   = 'ellipse'
        n = n + 1
        asyn1(n)   = 'end'
        asyn2(n)   = 'exit'
        n = n + 1
        asyn1(n)   = 'end'
        asyn2(n)   = 'quit'
        n = n + 1
        asyn1(n)   = 'end'
        asyn2(n)   = 'split'
        n = n + 1
        asyn1(n)   = 'enddata'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'enddo'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'endif'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'environment'
        asyn2(n)   = 'env'
        n = n + 1
        asyn1(n)   = 'environment'
        asyn2(n)   = 'setup'
        n = n + 1
        asyn1(n)   = 'error'
        asyn2(n)   = 'err'
        n = n + 1
        asyn1(n)   = 'euler'
        asyn2(n)   = 'Euler'
        n = n + 1
        asyn1(n)   = 'event'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'exchange'
        asyn2(n)   = 'exch'
        n = n + 1
        asyn1(n)   = 'exp'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'extrema'
        asyn2(n)   = 'extr'
        n = n + 1
        asyn1(n)   = 'fact'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'factor'
        asyn2(n)   = 'totient'
        n = n + 1
        asyn1(n)   = 'family'
        asyn2(n)   = 'fam'
        n = n + 1
        asyn1(n)   = 'fit'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'focus'
        asyn2(n)   = 'foc'
        n = n + 1
        asyn1(n)   = 'goto'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'gcd'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'grads'
        asyn2(n)   = 'grad'
        n = n + 1
        asyn1(n)   = 'h'
        asyn2(n)   = 'undefined'
        asyncmd(n) = 'plot'
        n = n + 1
        asyn1(n)   = 'help'
        asyn2(n)   = 'h'
        n = n + 1
        asyn1(n)   = 'hex'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'hyperb'
        asyn2(n)   = 'saddle'
        n = n + 1
        asyn1(n)   = 'i/o'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'icalc'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'if'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'in'
        asyn2(n)   = 'undefined'
        asyncmd(n) = 'hex'
        n = n + 1
        asyn1(n)   = 'increment'
        asyn2(n)   = 'incr'
        n = n + 1
        asyn1(n)   = 'index'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'indo'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'input'
        asyn2(n)   = 'call'
        n = n + 1
        asyn1(n)   = 'input'
        asyn2(n)   = 'i'
        n = n + 1
        asyn1(n)   = 'input'
        asyn2(n)   = 'in'
        n = n + 1
        asyn1(n)   = 'input'
        asyn2(n)   = 'r'
        n = n + 1
        asyn1(n)   = 'input'
        asyn2(n)   = 'rd'
        n = n + 1
        asyn1(n)   = 'input'
        asyn2(n)   = 'read'
        n = n + 1
        asyn1(n)   = 'insert'
        asyn2(n)   = 'ins'
        n = n + 1
        asyn1(n)   = 'int'
        asyn2(n)   = 'undefined'
        asyncmd(n) = 'icalc'
        n = n + 1
        asyn1(n)   = 'int'
        asyn2(n)   = 'undefined'
        asyncmd(n) = 'variable'
        n = n + 1
        asyn1(n)   = 'intcirc'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'intersect'
        asyn2(n)   = 'int'
        asyncmd(n) = 'quadric'
        n = n + 1
        asyn1(n)   = 'intersect'
        asyn2(n)   = 'inter'
        asyncmd(n) = 'quadric'
        n = n + 1
        asyn1(n)   = 'invert'
        asyn2(n)   = 'inv'
        n = n + 1
        asyn1(n)   = 'iris'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'k'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'kiss'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'last'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'lcm'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'limits'
        asyn2(n)   = 'lim'
        n = n + 1
        asyn1(n)   = 'line'
        asyn2(n)   = 'l'
        n = n + 1
        asyn1(n)   = 'line'
        asyn2(n)   = 'ln'
        n = n + 1
        asyn1(n)   = 'linear'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'list'
        asyn2(n)   = 'display'
        asyncmd(n) = 'list'
        n = n + 1
        asyn1(n)   = 'list'
        asyn2(n)   = 'print'
        asyncmd(n) = 'list'
        n = n + 1
        asyn1(n)   = 'lock'
        asyn2(n)   = 'zzz'
        n = n + 1
        asyn1(n)   = 'log'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'log10'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'marker'
        asyn2(n)   = 'm'
        n = n + 1
        asyn1(n)   = 'marker'
        asyn2(n)   = 'mark'
        n = n + 1
        asyn1(n)   = 'math'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'max'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'maxwell'
        asyn2(n)   = 'Maxwell'
        n = n + 1
        asyn1(n)   = 'mcvol'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'mean'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'mesh'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'min'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'misc'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'mod'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'move'
        asyn2(n)   = 'mv'
        n = n + 1
        asyn1(n)   = 'move'
        asyn2(n)   = 'trans'
        n = n + 1
        asyn1(n)   = 'move'
        asyn2(n)   = 'translate'
        n = n + 1
        asyn1(n)   = 'new'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'nest'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'nint'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'nobin'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'nomesh'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'undefined'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'norepl'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'normal'
        asyn2(n)   = 'norm'
        n = n + 1
        asyn1(n)   = 'null'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'object'
        asyn2(n)   = 'obj'
        n = n + 1
        asyn1(n)   = 'octal'
        asyn2(n)   = 'oct'
        asyncmd(n) = 'icalc, big'
        n = n + 1
        asyn1(n)   = 'off'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'on'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'operator'
        asyn2(n)   = 'op'
        n = n + 1
        asyn1(n)   = 'operator'
        asyn2(n)   = 'oper'
        n = n + 1
        asyn1(n)   = 'ortho'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'out'
        asyn2(n)   = 'undefined'
        asyncmd(n) = 'hex'
        n = n + 1
        asyn1(n)   = 'outer'
        asyn2(n)   = 'cross'
        n = n + 1
        asyn1(n)   = 'outline'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'output'
        asyn2(n)   = 'o'
        n = n + 1
        asyn1(n)   = 'output'
        asyn2(n)   = 'out'
        n = n + 1
        asyn1(n)   = 'output'
        asyn2(n)   = 'w'
        n = n + 1
        asyn1(n)   = 'output'
        asyn2(n)   = 'wr'
        n = n + 1
        asyn1(n)   = 'output'
        asyn2(n)   = 'write'
        n = n + 1
        asyn1(n)   = 'page'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'parameter'
        asyn2(n)   = 'param'
        n = n + 1
        asyn1(n)   = 'parallel'
        asyn2(n)   = 'par'
        n = n + 1
        asyn1(n)   = 'parse'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'path'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'pdf'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'perm'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'perspective'
        asyn2(n)   = 'pers'
        n = n + 1
        asyn1(n)   = 'phi'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'pi'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'planar'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'planck'
        asyn2(n)   = 'Planck'
        n = n + 1
        asyn1(n)   = 'plane'
        asyn2(n)   = 'pl'
        n = n + 1
        asyn1(n)   = 'plot'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'point'
        asyn2(n)   = 'p'
        n = n + 1
        asyn1(n)   = 'point'
        asyn2(n)   = 'pnt'
        n = n + 1
        asyn1(n)   = 'point'
        asyn2(n)   = 'pt'
        n = n + 1
        asyn1(n)   = 'polar'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'polygon'
        asyn2(n)   = 'pg'
        n = n + 1
        asyn1(n)   = 'polygon'
        asyn2(n)   = 'polyg'
        n = n + 1
        asyn1(n)   = 'polyhedron'
        asyn2(n)   = 'ph'
        n = n + 1
        asyn1(n)   = 'polyhedron'
        asyn2(n)   = 'polyh'
        n = n + 1
        asyn1(n)   = 'polynomial'
        asyn2(n)   = 'poly'
        n = n + 1
        asyn1(n)   = 'power'
        asyn2(n)   = 'pow'
        n = n + 1
        asyn1(n)   = 'prime'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'project'
        asyn2(n)   = 'proj'
        n = n + 1
        asyn1(n)   = 'prompt'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'proximal'
        asyn2(n)   = 'prox'
        n = n + 1
        asyn1(n)   = 'quadric'
        asyn2(n)   = 'q'
        n = n + 1
        asyn1(n)   = 'quadric'
        asyn2(n)   = 'quad'
        n = n + 1
        asyn1(n)   = 'rad/deg'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'radial'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'radians'
        asyn2(n)   = 'rad'
        n = n + 1
        asyn1(n)   = 'radians'
        asyn2(n)   = 'radian'
        n = n + 1
        asyn1(n)   = 'ran'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'random'
        asyn2(n)   = '?'
        n = n + 1
        asyn1(n)   = 'ratio'
        asyn2(n)   = 'rat'
        n = n + 1
        asyn1(n)   = 'rcyl'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'redo'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'reflect'
        asyn2(n)   = 'refl'
        n = n + 1
        asyn1(n)   = 'rel'
        asyn2(n)   = '*'
        asyncmd(n) = 'vector'
        n = n + 1
        asyn1(n)   = 'relax'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'reset'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'rename'
        asyn2(n)   = 'sw'
        n = n + 1
        asyn1(n)   = 'rename'
        asyn2(n)   = 'switch'
        n = n + 1
        asyn1(n)   = 'repack'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'return'
        asyn2(n)   = 'rtn'
        n = n + 1
        asyn1(n)   = 'rgold'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'root'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'rootf'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'roots'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'row'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'rotate'
        asyn2(n)   = 'rot'
        n = n + 1
        asyn1(n)   = 'rsph'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'save'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'sample'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'scale'
        asyn2(n)   = 'sc'
        n = n + 1
        asyn1(n)   = 'scale'
        asyn2(n)   = 'uniform'
        asyncmd(n) = 'oper'
        n = n + 1
        asyn1(n)   = 'serial'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'search'
        asyn2(n)   = 'find'
        n = n + 1
        asyn1(n)   = 'series'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'side'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'sign'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'sin'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'sinh'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'size'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'slice'
        asyn2(n)   = 'cut'
        n = n + 1
        asyn1(n)   = 'solve'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'sort'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'sphere'
        asyn2(n)   = 'sph'
        n = n + 1
        asyn1(n)   = 'spherical'
        asyn2(n)   = 'sph'
        asyncmd(n) = 'coord'
        n = n + 1
        asyn1(n)   = 'spin'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'sqrt'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'status'
        asyn2(n)   = 'stat'
        n = n + 1
        asyn1(n)   = 'stddev'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'steiner'
        asyn2(n)   = 'stein'
        n = n + 1
        asyn1(n)   = 'sudoku'
        asyn2(n)   = 'su'
        n = n + 1
        asyn1(n)   = 'sum'
        asyn2(n)   = 'add'
        n = n + 1
        asyn1(n)   = 'symbol'
        asyn2(n)   = 'sym'
        n = n + 1
        asyn1(n)   = 'symbol'
        asyn2(n)   = 'symb'
        n = n + 1
        asyn1(n)   = 'synonym'
        asyn2(n)   = 'syn'
        n = n + 1
        asyn1(n)   = 'tables'
        asyn2(n)   = 'sizes'
        n = n + 1
        asyn1(n)   = 'tag'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'tangent'
        asyn2(n)   = 'tan'
        n = n + 1
        asyn1(n)   = 'tanh'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'temp'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'test'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'tetrahedron'
        asyn2(n)   = 'tet'
        n = n + 1
        asyn1(n)   = 'tetrahedron'
        asyn2(n)   = 'tetra'
        n = n + 1
        asyn1(n)   = 'then'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'theta'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'thru'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'time'
        asyn2(n)   = 't'
        n = n + 1
        asyn1(n)   = 'title'
        asyn2(n)   = 'id'
        n = n + 1
        asyn1(n)   = 'tol'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'trace'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'track'
        asyn2(n)   = 'trk'
        n = n + 1
        asyn1(n)   = 'triangle'
        asyn2(n)   = 'tri'
        n = n + 1
        asyn1(n)   = 'trig'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'triple'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'tty'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'twist'
        asyn2(n)   = 'tw'
        n = n + 1
        asyn1(n)   = 'types'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'un'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'undo'
        asyn2(n)   = 'u'
        n = n + 1
        asyn1(n)   = 'unit'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'v'
        asyn2(n)   = 'undefined'
        asyncmd(n) = 'plot'
        n = n + 1
        asyn1(n)   = 'vacuum'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'value'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'variable'
        asyn2(n)   = 's'
        n = n + 1
        asyn1(n)   = 'variable'
        asyn2(n)   = 'set'
        n = n + 1
        asyn1(n)   = 'variable'
        asyn2(n)   = 'var'
        n = n + 1
        asyn1(n)   = 'vector'
        asyn2(n)   = 'v'
        n = n + 1
        asyn1(n)   = 'vector'
        asyn2(n)   = 'vect'
        n = n + 1
        asyn1(n)   = 'vi'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'viewfactor'
        asyn2(n)   = 'view'
        n = n + 1
        asyn1(n)   = 'void'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'volume'
        asyn2(n)   = 'vol'
        n = n + 1
        asyn1(n)   = 'walk'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'when'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'where'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'wien'
        asyn2(n)   = 'Wien'
        n = n + 1
        asyn1(n)   = 'x'
        asyn2(n)   = 'undefined'
        asyncmd(n) = 'plot'
        n = n + 1
        asyn1(n)   = 'x'
        asyn2(n)   = 'X'
        n = n + 1
        asyn1(n)   = 'xor'
        asyn2(n)   = 'undefined'
        n = n + 1
        asyn1(n)   = 'y'
        asyn2(n)   = 'undefined'
        asyncmd(n) = 'plot'
        n = n + 1
        asyn1(n)   = 'y'
        asyn2(n)   = 'Y'
        n = n + 1
        asyn1(n)   = 'yes'
        asyn2(n)   = 'undefined'
        asyncmd(n) = 'delete'
        n = n + 1
        asyn1(n)   = 'yes'
        asyn2(n)   = 'y'
        asyncmd(n) = 'output'
        n = n + 1
        asyn1(n)   = 'z'
        asyn2(n)   = 'undefined'
        asyncmd(n) = 'plot'
        n = n + 1
        asyn1(n)   = 'z'
        asyn2(n)   = 'Z'
        n = n + 1
        asyn1(n)   = 'zone'
        asyn2(n)   = 'z'
        n = n + 1
        asyn1(n)   = 'zone'
        asyn2(n)   = 'zn'
        n = n + 1
        asyn1(n)   = 'zoom'
        asyn2(n)   = 'undefined'

        nsyns = n

        go to 999

      endif                           ! nword = 0

cbugc____ DEBUG begins.
cbug 9901 format ('synonym DEBUG.  n=',i3,'  asyn1=',a16,'  asyn2=',a16)
cbug      write (   6, 9901) (n, asyn1(n), asyn2(n), n   = 1, nsyns)
cbug      write (iout, 9901) (n, asyn1(n), asyn2(n), n   = 1, nsyns)
cbugc____ DEBUG ends.

c=======================================================================********

c.... Input line:  synonym all

 8120 format (/ 'Number of synonyms = ',i5)

      if ((nword .eq. 2)         .and.
     &    (aword(2) .eq. 'all')) then
        nsynx = 0

        do 120 n = 1, nsyns
          if (asyn1(n) .eq. ' ') go to 120
          if (asyn2(n) .eq. ' ') go to 120
          if (asyn2(n) .eq. 'undefined') go to 120
          nsynx = nsynx + 1
          call synout (n, n)
  120   continue

        write (   6, 8120) nsynx
        write (iout, 8120) nsynx

        write (   6, "('')")
        write (iout, "('')")

        aword(1) = 'symbol'
        call symbol

        write (   6, "('')")
        write (iout, "('')")

        aword(1) = 'alias'
        call alias

        go to 999
      endif

c=======================================================================********

c.... Input line:  synonym none

 8125 format (/ 'Number with undefined synonyms = ',i5)

      if ((nword .eq. 2)          .and.
     &    (aword(2) .eq. 'none')) then
        nsynx = 0

        do 125 n = 1, nsyns
          if (asyn1(n) .eq. ' ') go to 125
          if (asyn2(n) .eq. ' ') go to 125
          if (asyn2(n) .eq. 'undefined') then
            nsynx = nsynx + 1
            call synout (n, n)
          endif
  125   continue

        write (   6, 8125) nsynx
        write (iout, 8125) nsynx

        go to 999

      endif
c=======================================================================********

c.... Input line:  synonym SYNAME1 SYNAME2 SYNAME3 ...

 8128 format ('  synonym ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  No synonym begins with character:  ',a)
 8130 format ('  synonym ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  No such command, key word or synonym exists:  ',a)

      do 200 nw = 2, nword            ! Loop over command and key words.

        nsynx = 0

        if (lword(nw) .eq. 1) then    ! Synonyms starting with this letter.

          afirst = aword(nw)

          do 140 n = 1, nsyns
            afirst1 = asyn1(n)
            afirst2 = asyn2(n)
            if ((afirst .eq. afirst1)  .or.
     &          (afirst .eq. afirst2)) then
              if (asyn2(n) .eq. 'undefined') go to 140
              nsynx = nsynx + 1
              call synout (n, n)
            endif
  140     continue

          if (nsynx .eq. 0) then
            write (   6, 8128) ainput, ninput, aword(nw)
            write (iout, 8128) ainput, ninput, aword(nw)
          endif

        else                          ! Synonyms for this word.

          do 170 n = 1, nsyns
            if ((aword(nw) .eq. asyn1(n))  .or.
     &          (aword(nw) .eq. asyn2(n))) then
              nsynx = nsynx + 1
              call synout (n, n)
            endif
  170     continue

          if (nsynx .eq. 0) then
            write (   6, 8130) ainput, ninput, aword(nw)
            write (iout, 8130) ainput, ninput, aword(nw)
          endif

        endif                         ! Tested length of word.

  200 continue                        ! End of loop over command and key words.

c.... Look for symbols and aliases.

      do 300 nw = 2, nword            ! Loop over command and key words.

        if (lword(nw) .eq. 1) then    ! Symbols, aliases starting with letter.

c....     Match only first character.

          afirst = aword(nw)

          if (nsymbs .gt. 0) then
            do 250 n = 1, nsymbs
              afirst1 = asymbl(n)
              afirst2 = asymbr(n)
              if ((afirst .eq. afirst1)  .or.
     &            (afirst .eq. afirst2)) then
                call symbout (n, n)
              endif
  250       continue
          endif

          if (nalias .gt. 0) then
            do 260 n = 1, nalias
              afirst1 = alias1(n)
              afirst2 = alias2(n)
              if ((afirst .eq. afirst1)  .or.
     &            (afirst .eq. afirst2)) then
                call alout (n, n)
              endif
  260       continue
          endif

        else                          ! Symbols and aliases for this word.

c....     Match whole word.

          if (nsymbs .gt. 0) then
            do 180 n = 1, nsymbs
              if ((aword(nw) .eq. asymbl(n))  .or.
     &            (aword(nw) .eq. asymbr(n))) then
                call symbout (n, n)
              endif
  180       continue
          endif

          if (nalias .gt. 0) then
            do 190 n = 1, nalias
              if ((aword(nw) .eq. alias1(n))  .or.
     &            (aword(nw) .eq. alias2(n))) then
                call alout (n, n)
              endif
  190       continue
          endif

        endif                         ! Tested length of word.

  300 continue                        ! End of loop over command and key words.

c=======================================================================********

  999 return

c.... End of subroutine synonym.      (+1 line)
      end
