      subroutine tables

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  tables   Updated     2006 June 2 15:30.
c               tables   Originated  1995 January 6 15:20.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To display the maximum sizes of the data tables for various
c               objects, the current space used, and the command types used
c               to create and display them.
c
c     Logic:    Entry points:  tables.
c tables        Called by:  helpall, main, tables* .
c
c tables        Calls:  repack.
c
c     Biblio:   ?
c
c     Glossary:
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

      character*80 aword1x
      character*80 aword2x

c=======================================================================********

 8110 format ('  Command "table":  acceptable input lines',
     &  ' include:' /
     &  '  "table [help]"       Display this message, and'
     &  ' display the maximum sizes of' /
     &  '    the data tables for various objects, the current space',
     &  ' used, and the' /
     &  '    command types used to create and display them.' /
     &  '  Synonyms:  [help, h], [tables, sizes].' )

      if ((nword .eq. 1) .or.
     &   ((nword .eq. 2) .and.
     &   ((aword(2) .eq. 'help') .or.
     &    (aword(2) .eq. 'h')))) then
        write (   6, 8110)
        write (iout, 8110)
      endif

c=======================================================================********

c.... Input line:  tables [help]

c.... Repack memory.

      nword    = 2
      aword1x  = aword(1)
      aword2x  = aword(2)
      aword(1) = 'repack'
      aword(2) = 'all'

      call repack

      aword(1) = aword1x
      aword(2) = aword2x

c.... Display the maximum sizes of the data tables for various objects,
c....   the current space used,
c....   and the command types used to create and display them.

 8010 format (/
     &  '   Object type                               #   Max',
     &  '  Command type'//
     &  '   Aliases                              ',2i6,'  alias    ' /
     &  '   Annular disks                        ',2i6,'  disk     ' /
     &  '   Big integers                         ',2i6,'  big      ' /
     &  '   Digits per big integer               ',6x,i6,'  big      ' /
     &  '   Bounding surfaces per zone           ',6x,i6,'  zone     ' /
     &  '   Bricks (coordinate solids)           ',2i6,'  brick    ' /
     &  '   Clusters of points                   ',2i6,'  cluster  ' /
     &  '   Lines                                ',2i6,'  line     ' /
     &  '   Markers                              ',2i6,'  marker   ' /
     &  '   Operators                            ',2i6,'  operator ' /
     &  '   Plot array columns                   ',2i6,'  plot     ' /
     &  '   Plot array lines                     ',2i6,'  plot     ' /
     &  '   Plot point markers                   ',2i6,'  plot     ' /
     &  '   Plot points                          ',2i6,'  plot     ' /
     &  '   Point-cluster pairs                  ',2i6,'  cluster  ' /
     &  '   Points                               ',2i6,'  point    ' /
     &  '   Polygons                             ',2i6,'  polygon  ' /
     &  '   Polyhedrons                          ',2i6,'  polyh    ' )

 8020 format (
     &  '   Probability bin-pdf pairs            ',2i6,'  pdf      ' /
     &  '   Probability bins                     ',2i6,'  bin      ' /
     &  '   Probability distribution functions   ',2i6,'  pdf      ' /
     &  '   Quadric surfaces                     ',2i6,'  (all)    ' /
     &  '     Planes                             ',12x,'  plane    ' /
     &  '     Spheres                            ',12x,'  sphere   ' /
     &  '     Circular cylinders                 ',12x,'  cylinder ' /
     &  '     Circular cones                     ',12x,'  cone     ' /
     &  '     Ellipsoids                         ',12x,'  ellipsoid' /
     &  '     Axisymmetric quadric surfaces      ',12x,'  axisym   ' /
     &  '     General quadric surfaces           ',12x,'  quadric  ' /
     &  '   Saved input lines (max 80 characters)',2i6,'  input    ' /
     &  '   Symbols                              ',2i6,'  symbol   ' /
     &  '   Synonyms                             ',2i6,'  synonym  ' /
     &  '   Temporary arrays                     ',2i6,'  (varies) ' /
     &  '   Tetrahedrons                         ',2i6,'  tetra    ' /
     &  '   Triangles                            ',2i6,'  triangle ' /
     &  '   Variables                            ',2i6,'  variable ' /
     &  '   Vectors                              ',2i6,'  vector   ' /
     &  '   Vertices per polygon                 ',6x,i6,'  polygon  ' /
     &  '   Zones                                ',2i6,'  zone     ' )

      write (   6, 8010) nalias, naliasm, ndisks,  ndiskm, nbigm,
     &  nbigm, ndigm, nzquadm, nbricks, nbrickm, nclusts, nclustm,
     &  nlines, nlinem, nmarks, nmarkm, nopers, noperm,
     &  nplcols, nplcolm, nplines, nplinem,  nptmarks, nptmarkm,
     &  nplpts, nplptm, npairs, npairm,  npoints, npointm,
     &  npolygs, npolygm, npolyhs, npolyhm

      write (iout, 8010) nalias, naliasm, ndisks,  ndiskm,
     &  nbigm, ndigm, nzquadm, nbricks, nbrickm, nclusts, nclustm,
     &  nlines, nlinem, nmarks, nmarkm, nopers, noperm,
     &  nplcols, nplcolm, nplines, nplinem,  nptmarks, nptmarkm,
     &  nplpts, nplptm, npairs, npairm,  npoints, npointm,
     &  npolygs, npolygm, npolyhs, npolyhm

      write (   6, 8020) npdfxs, npdfxm, nbins, nbinm, npdfs, npdfm,
     &  nquads, nquadm, ncmds, ncmdm, nsymbs, nsymbm, nsyns, nsynm,
     &  ntemps, ntempm, ntets, ntetm, ntrigs, ntrigm, nvars, nvarm,
     &  nvectors, nvectm, nverpgm, nzones, nzonem

      write (iout, 8020) npdfxs, npdfxm, nbins, nbinm, npdfs, npdfm,
     &  nquads, nquadm, ncmds, ncmdm, nsymbs, nsymbm, nsyns, nsynm,
     &  ntemps, ntempm, ntets, ntetm, ntrigs, ntrigm, nvars, nvarm,
     &  nvectors, nvectm, nverpgm, nzones, nzonem

c=======================================================================********

      return

c.... End of subroutine tables.       (+1 line)
      end
