      subroutine tbank (ksecr)
 
c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  tbank    Updated     1996 November 11 15:20.
c               tbank    Originated  1993 May 11 14:10.
c
c     Author:   Arthur L. Edwards
c
c     Purpose:  To find machine time used.
c
c     Logic:    Entry points:  tbank.
c tbank         Called by:  geomend, main, status, timex.
c
c tbank         Calls:  (none).
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'
 
      common /atbank/ ibank           ! Milliseconds, bank account.
      common /atbank/ icpu            ! Milliseconds of CPU time used.
      common /atbank/ iprior          ! Priority.
      equivalence (fprior, iprior)    ! Priority.
      common /atbank/ itime(5)        ! Microseconds of CPU and I/O time.
      common /atbank/ itl(2)          ! Time limit in milliseconds, priority.
      common /atbank/ iwrd(3)         ! Time limit, prio(fp), bank pool.
 
cUNIc.... Get microseconds of CPU, I/O and system time.
cUNI 
cUNI      call izm00 (itime)
cUNIcbugc***Debug begins.
cUNIcbug 9801 format ('tbank itime=',5i12)
cUNIcbug      write (3, 9801) (itime(n), n = 1, 5)
cUNIcbugc***Debug ends.
cUNI
cUNI      ksecr = (itime(1) + itime(2) + itime(3) + 500) / 1000
cUNIcbugc***Debug begins.
cUNIcbug 9802 format ('tbank ksecr=',i12)
cUNIcbug      write (3, 9802) ksecr
cUNIcbugc***Debug ends.
cUNI 
cUNI 8001 format ('  GEOM millisec:  CPU =',i9,'.  I/O =',i9,'.  SYS = ',i9)
cUNI      icpu = (itime(1) + 500) / 1000  ! Milliseconds, CPU.
cUNI      write (iout, 8001) icpu, itime(2) / 1000, itime(3) / 1000
cUNIctem      write (   *, 8001) icpu, itime(2) / 1000, itime(3) / 1000
cUNIcbugc***Debug begins.
cUNIcbug 9803 format ('tbank icpu=',i12)
cUNIcbug      write (iout, 9803) icpu
cUNIcbugc***Debug ends.
cUNI 
cUNIc.... Get time limit, priority, and bank pool.
cUNI 
cUNI 8002 format (/ '  Time limit millisec =',i8,'.  Priority =',0pf5.2,
cUNI     &  '.  Bank millisec =',i8,'.')
cUNI 
cUNIc.... Get time limit, prio, bank pool (microseconds).
cUNI 
cUNI      call izm03 (iwrd)
cUNIcbugc***Debug begins.
cUNIcbug 9804 format ('tbank iwrd=',3i12)
cUNIcbug      write (iout, 9804) (iwrd(n), n = 1,3)
cUNIcbugc***Debug ends.
cUNI 
cUNI      itl(1) = iwrd(1) / 1000         ! Time limit, milliseconds.
cUNI      itl(2) = iwrd(2)                ! Floating point priority.
cUNI      iprior = itl(2)
cUNI      ibank  = iwrd(3) / 1000
cUNIcbugc***Debug begins.
cUNIctem      write (iout, 8002) itl(1), fprior, ibank
cUNIctem      write (   *, 8002) itl(1), fprior, ibank
cUNIcbugc***Debug ends.

cMEGc.... Get seconds of CPU, I/O and system time.
cMEG 
cMEG      ierr = mgustime (cputime, systime)
cMEG
cMEG 8005 format ('  GEOM time used, seconds (CPU, SYS, TOT) = ',3f11.3)
cMEG      tottime = cputime + systime
cMEG      write (iout, 8005) cputime, systime, tottime
cMEG
cMEG      ksecr = 1000.0 * tottime + 0.5

c-----------------------------------------------------------------------********

c.... Get seconds of CPU, I/O and system time.
 
c**** DEC:  need a substitute for mgustime.

cSUN      ierr = mgustime (cputime, systime)

      cputime = -1.e99
      systime = -1.e99

 8005 format ('  GEOM time used, seconds (CPU, SYS, TOT) = ',3f11.3)
      tottime = cputime + systime
      write (iout, 8005) cputime, systime, tottime

      ksecr = 1000.0 * tottime + 0.5
      ksecr = 9999999999

c-----------------------------------------------------------------------********
 
      return
 
c.... End of subroutine tbank.        (+1 line).
      end
