      subroutine varstore (nrep, n)

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  varstore Updated     1994 July 29 14:00.
c               varstore Originated  1994 July 29 14:00.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To find the index in the array of variables in which to store
c               the variable being created.
c
c     Logic:    Entry points:  varstore.
c varstore      Called by:  variable.
c
c varstore      Calls:  varout.
c
c     Biblio:   ?
c
c     Glossary:
c
c     n         Output   0 if variable array is full.  No room for a new
c                          variable.
c                          Positive if the index where the new variable is to
c                          be stored.
c
c     nrep      Output   0 if variable name is new, 1 if an old variable with
c                          the same name is being replaced.
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

      n = 0

c.... See if the variable name already exists.

 8110 format ('  WARNING:  replacing existing variable:  ',a)

      nrep = 0

      do 110 nvar = 1, nvars
        if (aword(2) .eq. avarbl(nvar)) then
          nrep = 1
          n = nvar
          write (   6, 8110) avarbl(nvar)
          write (iout, 8110) avarbl(nvar)
          call varout (nvar, nvar)
          go to 999
        endif
  110 continue

c.... See if a null variable can be replaced.

      do 120 nvar = 1, nvars
        if (avarbl(nvar) .eq. ' ') then
          n = nvar
          go to 999
        endif
  120 continue

c.... See if the maximum number of variables has been exceeded.

 8130 format ('  varstore ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Number of variables exceeds limit ',i5)

      if ((nvars + 1) .gt. nvarm) then
        write (   6, 8130) ainput, ninput, nvarm
        write (iout, 8130) ainput, ninput, nvarm
        n = 0
        go to 999
      endif

c.... Add a new variable at the end of the list.

      nvars = nvars + 1

      n = nvars

c=======================================================================********

  999 return

c.... End of subroutine varstore.     (+1 line)
      end
