      subroutine zout (n1, n2, amount)

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  zout     Updated     2003 March 20 18:00.
c               zout     Originated  1994 January 18 17:00.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To display the bounding quadric surfaces of zones n1 to n2.
c
c     Logic:    Entry points:  zout.
c zout          Called by:  cluster, copy, delete, distance, mcvol, point,
c               renamea, renamex, search, slice, track, where, znmake,
c               znstore, zone.
c
c zout          Calls:  quout.
c
c     Biblio:   ?
c
c     Glossary:
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

      character*8 amount              ! Amount of output, minimum or maximum.

c.... Initialize.

      nn1 = n1
      nn2 = n2
      if (nn1 .lt. 1) nn1 = 1
      if (nn2 .gt. nzones) nn2 = nzones

 8110 format ('  zout ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Zone ',a,' has undefined boundary',i3,':  ',a)
 8115 format ('  zout ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Zone ',a,' has duplicate boundary',i3,':  ',a)
 8130 format ('zone ',a,' = ',a1,1x,a)
 8140 format ('zone ',a,' & ',a1,1x,a)
 8145 format ('  Number of quadric surfaces bounding zone ',a,
     &  ' = ',i3,'.')
 8150 format ('  Volume, est err ',1p2e20.12)

      do 160 n = nn1, nn2             ! Loop over zones.

        if (azone(n) .eq. ' ') go to 160

        do 120 nn = 1, nzquads(n)     ! Loop over zone boundaries.

          do 110 nq = 1, nquads
            if (aquad(nq) .eq. azquad(nn,n)) go to 112
  110     continue
          write (   6, 8110) ainput, ninput, azone(n), nn, azquad(nn,n)
          write (iout, 8110) ainput, ninput, azone(n), nn, azquad(nn,n)

  112     do 115 nnn = 1, nn - 1
            if (azquad(nn,n) .eq. azquad(nnn,n)) then
              write (   6, 8115) ainput, ninput, azone(n), nn,
     &          azquad(nn,n)
              write (iout, 8115) ainput, ninput, azone(n), nn,
     &          azquad(nn,n)
            endif
  115     continue

  120   continue                      ! End of loop over zone boundaries.

        nnmax = 1

        write (   6, 8130) azone(n), azsign(1,n), azquad(1,n)
        write (iout, 8130) azone(n), azsign(1,n), azquad(1,n)

        if (nzquads(n) .gt. 1) then
          write (   6, 8140) (azone(n), azsign(nn,n), azquad(nn,n),
     &      nn = 2, nzquads(n))
          write (iout, 8140) (azone(n), azsign(nn,n), azquad(nn,n),
     &      nn = 2, nzquads(n))
        endif

        write (   6, 8145) azone(n), nzquads(n)
        write (iout, 8145) azone(n), nzquads(n)

        if (amount .eq. 'maximum') then  ! Print quadric surface data.

          do 150 nn = 1, nzquads(n)   ! Loop over zone boundaries.

            do 130 nq = 1, nquads
              if (aquad(nq) .eq. azquad(nn,n)) then
                call quout (nq, nq, 'min', nerrq)
                go to 150
              endif
  130       continue

  150     continue                    ! End of loop over zone boundaries.

        endif                         ! Printing quadric surface data.

        if (volz(n) .ne. 0.0) then
          write (   6, 8150) volz(n), volzerr(n)
          write (iout, 8150) volz(n), volzerr(n)
        endif

  160 continue                        ! End of loop over zones.

      return

c.... End of subroutine zout.         (+1 line)
      end
